package codecLib.g728;

final class g728_gain
  implements g728_constants
{
  static final double M_LN10 = 2.302585092994046D;
  static final double M_LOG10E = 0.4342944819032518D;
  static final double FACGP0 = 0.90625D;
  static final double FACGP1 = 0.8212890625D;
  static final double FACGP2 = 0.74432373046875D;
  static final double FACGP3 = 0.67449951171875D;
  static final double FACGP4 = 0.61126708984375D;
  static final double FACGP5 = 0.553955078125D;
  static final double FACGP6 = 0.50201416015625D;
  static final double FACGP7 = 0.4549560546875D;
  static final double FACGP8 = 0.41229248046875D;
  static final double FACGP9 = 0.3736572265625D;
  static final double[] GAIN_wnrlg = { 0.583953857421875D, 0.6053466796875D, 0.62750244140625D, 0.650482177734375D, 0.67431640625D, 0.699005126953125D, 0.724578857421875D, 0.751129150390625D, 0.77862548828125D, 0.80712890625D, 0.836669921875D, 0.8673095703125D, 0.899078369140625D, 0.9320068359375D, 0.96148681640625D, 0.982757568359375D, 0.995635986328125D, 0.999969482421875D, 0.995819091796875D, 0.983154296875D, 0.962066650390625D, 0.932769775390625D, 0.8955078125D, 0.8505859375D, 0.79840087890625D, 0.7393798828125D, 0.674072265625D, 0.602996826171875D, 0.526763916015625D, 0.446014404296875D, 0.361480712890625D, 0.273834228515625D, 0.183868408203125D, 0.09234619140625D };
  static final double DIMINV = 0.2D;
  static final int GOFF = 32;
  static final int LPCLG = 10;
  static final int NONRLG = 20;
  static final int NUPDATE = 4;
  g728_filter_w gain_filter = new g728_filter_w();
  double[] recursive_gain = new double[11];
  double[] a_gain = new double[10];
  double[] past_gain = new double[34];

  g728_gain()
  {
    g728_utils.Clean(this.a_gain);
    g728_utils.Clean(this.past_gain);
    g728_utils.Clean(this.recursive_gain);
    this.a_gain[0] = -1.0D;
  }

  final void reset()
  {
    g728_utils.Clean(this.a_gain);
    g728_utils.Clean(this.past_gain);
    g728_utils.Clean(this.recursive_gain);
    this.a_gain[0] = -1.0D;
    this.gain_filter.reset();
  }

  final double Predict()
  {
    double d1 = 32.0D - this.gain_filter.delay[9] * this.a_gain[9];
    for (int i = 8; i >= 0; i--)
    {
      double d2 = this.gain_filter.delay[i];
      d1 -= d2 * this.a_gain[i];
      this.gain_filter.delay[(i + 1)] = d2;
    }
    if (d1 < 0.0D)
      d1 = 0.0D;
    if (d1 > 60.0D)
      d1 = 60.0D;
    d1 = Math.exp(0.1151292546497023D * d1);
    return d1;
  }

  final void Update(double[] paramArrayOfDouble)
  {
    double d = paramArrayOfDouble[0] * paramArrayOfDouble[0] + paramArrayOfDouble[1] * paramArrayOfDouble[1] + paramArrayOfDouble[2] * paramArrayOfDouble[2] + paramArrayOfDouble[3] * paramArrayOfDouble[3] + paramArrayOfDouble[4] * paramArrayOfDouble[4];
    d *= 0.2D;
    if (d < 1.0D)
      d = 1.0D;
    d = 4.342944819032518D * Math.log(d);
    this.gain_filter.delay[0] = (d - 32.0D);
  }

  final void Adapter()
  {
    double[] arrayOfDouble1 = new double[1];
    double[] arrayOfDouble2 = new double[10];
    double[] arrayOfDouble3 = new double[11];
    double[] arrayOfDouble4 = new double[34];
    g728_utils.Clean(arrayOfDouble3);
    g728_utils.Left_shift(this.past_gain, 0, 4, 30);
    for (int i = 0; i < 4; i++)
      this.past_gain[(30 + i)] = this.gain_filter.delay[(3 - i)];
    g728_utils.Windowing(arrayOfDouble4, 0, this.past_gain, 0, GAIN_wnrlg, 34);
    for (int j = 0; j <= 10; j++)
      this.recursive_gain[j] *= 0.75D;
    g728_utils.Corel_11(this.recursive_gain, 0, arrayOfDouble4, 10, 4);
    g728_utils.Corel_11(arrayOfDouble3, 0, arrayOfDouble4, 14, 20);
    for (int k = 0; k <= 10; k++)
      arrayOfDouble3[k] += this.recursive_gain[k];
    arrayOfDouble3[0] *= 1.00390625D;
    if (g728_utils.Levdur_10(arrayOfDouble2, arrayOfDouble3, arrayOfDouble1) != 0.0D)
    {
      this.a_gain[0] = (0.90625D * arrayOfDouble2[0]);
      this.a_gain[1] = (0.8212890625D * arrayOfDouble2[1]);
      this.a_gain[2] = (0.74432373046875D * arrayOfDouble2[2]);
      this.a_gain[3] = (0.67449951171875D * arrayOfDouble2[3]);
      this.a_gain[4] = (0.61126708984375D * arrayOfDouble2[4]);
      this.a_gain[5] = (0.553955078125D * arrayOfDouble2[5]);
      this.a_gain[6] = (0.50201416015625D * arrayOfDouble2[6]);
      this.a_gain[7] = (0.4549560546875D * arrayOfDouble2[7]);
      this.a_gain[8] = (0.41229248046875D * arrayOfDouble2[8]);
      this.a_gain[9] = (0.3736572265625D * arrayOfDouble2[9]);
    }
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.g728_gain
 * JD-Core Version:    0.6.0
 */