package codecLib.g729;

final class G729Code
  implements Constants
{
  private byte[] data = new byte[10];

  final short getL0()
  {
    return (short)((this.data[0] & 0x80) >>> 7);
  }

  final void setL0(short paramShort)
  {
    int tmp5_4 = 0;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0x7F);
    int tmp17_16 = 0;
    byte[] tmp17_13 = this.data;
    tmp17_13[tmp17_16] = (byte)(tmp17_13[tmp17_16] | paramShort << 7);
  }

  final short getL1()
  {
    return (short)(this.data[0] & 0x7F);
  }

  final void setL1(short paramShort)
  {
    int tmp5_4 = 0;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0x80);
    int tmp18_17 = 0;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort);
  }

  final short getL2()
  {
    return (short)((this.data[1] & 0xF8) >>> 3);
  }

  final void setL2(short paramShort)
  {
    int tmp5_4 = 1;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0x7);
    int tmp17_16 = 1;
    byte[] tmp17_13 = this.data;
    tmp17_13[tmp17_16] = (byte)(tmp17_13[tmp17_16] | paramShort << 3);
  }

  final short getL3()
  {
    int i = 0;
    i = (short)(i | (short)((this.data[1] & 0x7) << 2));
    i = (short)(i | (short)((this.data[2] & 0xC0) >>> 6));
    return (short) i;
  }

  final void setL3(short paramShort)
  {
    int tmp5_4 = 1;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xF8);
    int tmp18_17 = 1;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort >>> 2);
    int tmp31_30 = 2;
    byte[] tmp31_27 = this.data;
    tmp31_27[tmp31_30] = (byte)(tmp31_27[tmp31_30] & 0x3F);
    int tmp43_42 = 2;
    byte[] tmp43_39 = this.data;
    tmp43_39[tmp43_42] = (byte)(tmp43_39[tmp43_42] | (paramShort & 0x3) << 6);
  }

  final short getP1()
  {
    return (short)((this.data[2] & 0x3F) << 2 | (this.data[3] & 0xC0) >>> 6);
  }

  final void setP1(short paramShort)
  {
    int tmp5_4 = 2;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xC0);
    int tmp18_17 = 2;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort >>> 2);
    int tmp31_30 = 3;
    byte[] tmp31_27 = this.data;
    tmp31_27[tmp31_30] = (byte)(tmp31_27[tmp31_30] & 0x3F);
    int tmp43_42 = 3;
    byte[] tmp43_39 = this.data;
    tmp43_39[tmp43_42] = (byte)(tmp43_39[tmp43_42] | paramShort << 6);
  }

  final short getP0()
  {
    return (short)((this.data[3] & 0x20) >>> 5);
  }

  final void setP0(short paramShort)
  {
    int tmp5_4 = 3;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xDF);
    int tmp18_17 = 3;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort << 5);
  }

  final short getC1()
  {
    int i = 0;
    i = (short)(i | (short)((this.data[3] & 0x1F) << 8));
    i = (short)(i | (short)(this.data[4] & 0xFF));
    return (short) i;
  }

  final void setC1(short paramShort)
  {
    int tmp5_4 = 3;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xE0);
    int tmp18_17 = 3;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort >>> 8);
    this.data[4] = 0;
    int tmp39_38 = 4;
    byte[] tmp39_35 = this.data;
    tmp39_35[tmp39_38] = (byte)(tmp39_35[tmp39_38] | paramShort & 0xFF);
  }

  final short getS1()
  {
    return (short)((this.data[5] & 0xF0) >>> 4);
  }

  final void setS1(short paramShort)
  {
    int tmp5_4 = 5;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xF);
    int tmp17_16 = 5;
    byte[] tmp17_13 = this.data;
    tmp17_13[tmp17_16] = (byte)(tmp17_13[tmp17_16] | paramShort << 4);
  }

  final short getGA1()
  {
    return (short)((this.data[5] & 0xE) >>> 1);
  }

  final void setGA1(short paramShort)
  {
    int tmp5_4 = 5;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xF1);
    int tmp18_17 = 5;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort << 1);
  }

  final short getGB1()
  {
    int i = 0;
    i = (short)(i | (short)((this.data[5] & 0x1) << 3));
    i = (short)(i | (short)((this.data[6] & 0xE0) >>> 5));
    return (short) i;
  }

  final void setGB1(short paramShort)
  {
    int tmp5_4 = 5;
    byte[] tmp5_1 = this.data;
    tmp5_1[tmp5_4] = (byte)(tmp5_1[tmp5_4] & 0xFE);
    int tmp18_17 = 5;
    byte[] tmp18_14 = this.data;
    tmp18_14[tmp18_17] = (byte)(tmp18_14[tmp18_17] | paramShort >>> 3);
    byte[] tmp32_27 = this.data;
    tmp32_27[6] = (byte)(tmp32_27[6] & 0x1F);
    byte[] tmp45_40 = this.data;
    tmp45_40[6] = (byte)(tmp45_40[6] | (paramShort & 0x7) << 5);
  }

  final short getP2()
  {
    return (short)(this.data[6] & 0x1F);
  }

  final void setP2(short paramShort)
  {
    byte[] tmp6_1 = this.data;
    tmp6_1[6] = (byte)(tmp6_1[6] & 0xE0);
    byte[] tmp20_15 = this.data;
    tmp20_15[6] = (byte)(tmp20_15[6] | paramShort & 0x1F);
  }

  final short getC2()
  {
    int i = 0;
    i = (short)(i | (short)((this.data[7] & 0xFF) << 5));
    i = (short)(i | (short)((this.data[8] & 0xF8) >>> 3));
    return (short) i;
  }

  final void setC2(short paramShort)
  {
    byte[] tmp6_1 = this.data;
    tmp6_1[7] = (byte)(tmp6_1[7] & 0x0);
    byte[] tmp18_13 = this.data;
    tmp18_13[7] = (byte)(tmp18_13[7] | paramShort >>> 5);
    byte[] tmp32_27 = this.data;
    tmp32_27[8] = (byte)(tmp32_27[8] & 0x7);
    byte[] tmp45_40 = this.data;
    tmp45_40[8] = (byte)(tmp45_40[8] | (paramShort & 0x1F) << 3);
  }

  final short getS2()
  {
    return (short)((this.data[8] & 0x7) << 1 | (this.data[9] & 0x80) >>> 7);
  }

  final void setS2(short paramShort)
  {
    byte[] tmp6_1 = this.data;
    tmp6_1[8] = (byte)(tmp6_1[8] & 0xF8);
    byte[] tmp20_15 = this.data;
    tmp20_15[8] = (byte)(tmp20_15[8] | paramShort >> 1);
    byte[] tmp34_29 = this.data;
    tmp34_29[9] = (byte)(tmp34_29[9] & 0x7F);
    byte[] tmp47_42 = this.data;
    tmp47_42[9] = (byte)(tmp47_42[9] | paramShort << 7);
  }

  final short getGA2()
  {
    return (short)((this.data[9] & 0x70) >>> 4);
  }

  final void setGA2(short paramShort)
  {
    byte[] tmp6_1 = this.data;
    tmp6_1[9] = (byte)(tmp6_1[9] & 0x8F);
    byte[] tmp20_15 = this.data;
    tmp20_15[9] = (byte)(tmp20_15[9] | paramShort << 4);
  }

  final short getGB2()
  {
    return (short)(this.data[9] & 0xF);
  }

  final void setGB2(short paramShort)
  {
    byte[] tmp6_1 = this.data;
    tmp6_1[9] = (byte)(tmp6_1[9] & 0xF0);
    byte[] tmp20_15 = this.data;
    tmp20_15[9] = (byte)(tmp20_15[9] | paramShort);
  }

  G729Code()
  {
  }

  G729Code(byte[] paramArrayOfByte, int paramInt)
  {
    System.arraycopy(paramArrayOfByte, paramInt, this.data, 0, 10);
  }

  byte[] getData()
  {
    return this.data;
  }

  final void setData(byte[] paramArrayOfByte, int paramInt)
  {
    System.arraycopy(paramArrayOfByte, paramInt, this.data, 0, 10);
  }

  public final String toString()
  {
    StringBuffer localStringBuffer = new StringBuffer();
    localStringBuffer.append("L0=");
    localStringBuffer.append((short)((this.data[0] & 0x80) >>> 7));
    localStringBuffer.append("\n");
    localStringBuffer.append("L1=");
    localStringBuffer.append((short)(this.data[0] & 0x7F));
    localStringBuffer.append("\n");
    localStringBuffer.append("L2=");
    localStringBuffer.append((short)((this.data[1] & 0xF8) >>> 3));
    localStringBuffer.append("\n");
    localStringBuffer.append("L3=");
    localStringBuffer.append(getL3());
    localStringBuffer.append("\n");
    localStringBuffer.append("P1=");
    localStringBuffer.append((short)((this.data[2] & 0x3F) << 2 | (this.data[3] & 0xC0) >>> 6));
    localStringBuffer.append("\n");
    localStringBuffer.append("P0=");
    localStringBuffer.append((short)((this.data[3] & 0x20) >>> 5));
    localStringBuffer.append("\n");
    localStringBuffer.append("C1=");
    localStringBuffer.append(getC1());
    localStringBuffer.append("\n");
    localStringBuffer.append("S1=");
    localStringBuffer.append((short)((this.data[5] & 0xF0) >>> 4));
    localStringBuffer.append("\n");
    localStringBuffer.append("GA1=");
    localStringBuffer.append((short)((this.data[5] & 0xE) >>> 1));
    localStringBuffer.append("\n");
    localStringBuffer.append("GB1=");
    localStringBuffer.append(getGB1());
    localStringBuffer.append("\n");
    localStringBuffer.append("P2=");
    localStringBuffer.append((short)(this.data[6] & 0x1F));
    localStringBuffer.append("\n");
    localStringBuffer.append("C2=");
    localStringBuffer.append(getC2());
    localStringBuffer.append("\n");
    localStringBuffer.append("S2=");
    localStringBuffer.append((short)((this.data[8] & 0x7) << 1 | (this.data[9] & 0x80) >>> 7));
    localStringBuffer.append("\n");
    localStringBuffer.append("GA2=");
    localStringBuffer.append((short)((this.data[9] & 0x70) >>> 4));
    localStringBuffer.append("\n");
    localStringBuffer.append("GB2=");
    localStringBuffer.append((short)(this.data[9] & 0xF));
    localStringBuffer.append("\n");
    return localStringBuffer.toString();
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g729.G729Code
 * JD-Core Version:    0.6.0
 */