package codecLib.g729;

final class g729_encoder
  implements g729_constants
{
  private g729_preproc_filter preproc = new g729_preproc_filter();
  private g729_sinthesis_filter sinthesis = new g729_sinthesis_filter();
  private g729_sinthesis_filter error = new g729_sinthesis_filter();
  private g729_sinthesis_filter weghted_sinthesis_zero = new g729_sinthesis_filter();
  private g729_sinthesis_filter weghted_sinthesis_pole = new g729_sinthesis_filter();
  private g729_sinthesis_filter weghted_zero = new g729_sinthesis_filter();
  private g729_sinthesis_filter weghted_pole = new g729_sinthesis_filter();
  private g729_encode_filters filters = new g729_encode_filters();
  private g729_encode_speech speech = new g729_encode_speech();
  private g729_encode_lp lp = new g729_encode_lp();
  private float[] past_subframe_3 = new float[40];
  private float[] past_subframe_2 = new float[40];
  private float[] past_subframe_1 = new float[40];
  private float[] present_subframe_1 = new float[40];
  private float[] present_subframe_2 = new float[40];
  private float[] future_subframe = new float[40];
  private float[] weighted_speech = new float['à'];
  private float[] excitation = new float['Â'];
  private float[] q_quant_past_subframe_2 = new float[10];
  private float[] q_quant_present_subframe_2 = new float[10];
  private float[] l_quant_past_frame_4 = new float[10];
  private float[] l_quant_past_frame_3 = new float[10];
  private float[] l_quant_past_frame_2 = new float[10];
  private float[] l_quant_past_frame_1 = new float[10];
  private float[] exc_err = new float[4];

  public final void encode(G729Code paramG729Code, short[] paramArrayOfShort)
  {
    g729_encode_internal localg729_encode_internal1 = new g729_encode_internal();
    g729_encode_internal localg729_encode_internal2 = localg729_encode_internal1;
    int i = 30;
    g729_utils.validateData(paramArrayOfShort, 0);
    g729_preprocessor.g729_preproc_filter(this.speech.present_subframe_2, paramArrayOfShort, 0, this.filters);
    g729_preprocessor.g729_preproc_filter(this.speech.future_subframe, paramArrayOfShort, 40, this.filters);
    g729_lpc.g729_lp_analysis(this.lp, this.speech);
    g729_qualsp.g729_qua_lsp_encode(this.lp, paramG729Code);
    g729_common.g729_lsp_interpolation(this.lp.q_present_subframe_1, this.lp.q_past_subframe_2, this.lp.q_present_subframe_2);
    g729_common.g729_LSP2LP(localg729_encode_internal2.a_subframe1, this.lp.q_present_subframe_1);
    g729_common.g729_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
    g729_common.g729_LSP2LP(localg729_encode_internal2.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
    g729_common.g729_LSP2LP(localg729_encode_internal2.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
    float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
    this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
    this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
    for (int j = 0; j < 10; j++)
      this.lp.q_past_subframe_2[j] = this.lp.q_present_subframe_2[j];
    g729_pwf.g729_pwf(this.lp, this.speech, localg729_encode_internal2, this.filters);
    localg729_encode_internal2.T_opt = g729_pitch.g729_opla(this.speech.weighted_speech);
    g729_pitch.g729_impulse_response(localg729_encode_internal2, localg729_encode_internal2.a_quant_subframe1, localg729_encode_internal2.a_gamma1_subframe1, localg729_encode_internal2.a_gamma2_subframe1);
    g729_pitch.g729_target_1(localg729_encode_internal2, this.speech, this.filters);
    g729_pitch.g729_ad_cod_search_1(paramG729Code, localg729_encode_internal2, this.speech);
    g729_pitch.g729_adcb_gain(localg729_encode_internal2);
    localg729_encode_internal2.taming = g729_pitch.g729_test_err(this.exc_err, localg729_encode_internal2.T1, localg729_encode_internal2.frac_T1);
    if ((localg729_encode_internal2.taming == 1) && (localg729_encode_internal2.gp > 0.9499512F))
      localg729_encode_internal2.gp = 0.9499512F;
    int[] arrayOfInt = new int[1];
    arrayOfInt[0] = i;
    g729_acelpco.g729_fc_search(localg729_encode_internal2, localg729_encode_internal2.T1, this.speech.past_quan_gp, arrayOfInt);
    i = arrayOfInt[0];
    g729_quagain.g729_qua_gain(localg729_encode_internal2, this.speech);
    paramG729Code.setC1(localg729_encode_internal2.C);
    paramG729Code.setS1(localg729_encode_internal2.S);
    paramG729Code.setGA1(localg729_encode_internal2.GA);
    paramG729Code.setGB1(localg729_encode_internal2.GB);
    g729_quagain.g729_memory_update(this.speech, localg729_encode_internal2, this.filters, localg729_encode_internal2.a_quant_subframe1, this.speech.present_subframe_1);
    g729_pitch.g729_update_exc_err(this.exc_err, localg729_encode_internal2.gp_quan, localg729_encode_internal2.T1);
    g729_pitch.g729_impulse_response(localg729_encode_internal2, localg729_encode_internal2.a_quant_subframe2, localg729_encode_internal2.a_gamma1_subframe2, localg729_encode_internal2.a_gamma2_subframe2);
    g729_pitch.g729_target_2(localg729_encode_internal2, this.speech, this.filters);
    g729_pitch.g729_ad_cod_search_2(paramG729Code, localg729_encode_internal2, this.speech);
    g729_pitch.g729_adcb_gain(localg729_encode_internal2);
    localg729_encode_internal2.taming = g729_pitch.g729_test_err(this.exc_err, localg729_encode_internal2.T2, localg729_encode_internal2.frac_T2);
    if ((localg729_encode_internal2.taming == 1) && (localg729_encode_internal2.gp > 0.9499512F))
      localg729_encode_internal2.gp = 0.9499512F;
    arrayOfInt[0] = i;
    g729_acelpco.g729_fc_search(localg729_encode_internal2, localg729_encode_internal2.T2, this.speech.past_quan_gp, arrayOfInt);
    i = arrayOfInt[0];
    g729_quagain.g729_qua_gain(localg729_encode_internal2, this.speech);
    paramG729Code.setC2(localg729_encode_internal2.C);
    paramG729Code.setS2(localg729_encode_internal2.S);
    paramG729Code.setGA2(localg729_encode_internal2.GA);
    paramG729Code.setGB2(localg729_encode_internal2.GB);
    g729_quagain.g729_memory_update(this.speech, localg729_encode_internal2, this.filters, localg729_encode_internal2.a_quant_subframe2, this.speech.present_subframe_2);
    g729_pitch.g729_update_exc_err(this.exc_err, localg729_encode_internal2.gp_quan, localg729_encode_internal2.T2);
    float[] arrayOfFloat2 = this.speech.past_subframe_3;
    float[] arrayOfFloat3 = this.speech.past_subframe_2;
    this.speech.past_subframe_3 = this.speech.past_subframe_1;
    this.speech.past_subframe_2 = this.speech.present_subframe_1;
    this.speech.past_subframe_1 = this.speech.present_subframe_2;
    this.speech.present_subframe_1 = this.speech.future_subframe;
    this.speech.present_subframe_2 = arrayOfFloat2;
    this.speech.future_subframe = arrayOfFloat3;
    arrayOfFloat2 = this.speech.weighted_speech;
    for (int j = 0; j < 144; j++)
      arrayOfFloat2[j] = arrayOfFloat2[(j + 80)];
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2, int paramInt3)
  {
    int k = paramInt2;
    int j = paramInt1;
    for (int i = 0; i < paramInt3; i++)
    {
      encode(paramArrayOfByte, j, paramArrayOfShort, k);
      k += 80;
      j += 10;
    }
  }

  public void encode(G729Code[] paramArrayOfG729Code, short[] paramArrayOfShort, int paramInt1, int paramInt2)
  {
    if (paramArrayOfG729Code.length < paramInt2)
      throw new G729Exception(1);
    int j = paramInt1;
    for (int i = 0; i < paramInt2; i++)
    {
      encode(paramArrayOfG729Code[i], paramArrayOfShort, j);
      j += 80;
    }
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2)
  {
    G729Code localG729Code = new G729Code();
    g729_utils.validateCode(paramArrayOfByte, paramInt1);
    g729_utils.validateData(paramArrayOfShort, paramInt2);
    encode(localG729Code, paramArrayOfShort, paramInt2);
    byte[] arrayOfByte = localG729Code.getData();
    System.arraycopy(arrayOfByte, 0, paramArrayOfByte, paramInt1, 10);
  }

  public void encode(G729Code paramG729Code, short[] paramArrayOfShort, int paramInt)
  {
    short[] arrayOfShort = new short[80];
    g729_utils.validateData(paramArrayOfShort, paramInt);
    System.arraycopy(paramArrayOfShort, paramInt, arrayOfShort, 0, 80);
    encode(paramG729Code, arrayOfShort);
  }

  public g729_encoder()
  {
    this.preproc.a0 = 0.4636372F;
    this.preproc.a1 = -0.9272471F;
    this.preproc.a2 = 0.4636372F;
    this.preproc.b1 = 1.905947F;
    this.preproc.b2 = -0.911402F;
    this.preproc.x1 = 0.0F;
    this.preproc.x2 = 0.0F;
    this.preproc.y1 = 0.0F;
    this.preproc.y2 = 0.0F;
    this.speech.past_quan_gp = 0.2000122F;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float[] arrayOfFloat2 = this.lp.q_present_subframe_2;
    float[] arrayOfFloat3 = this.lp.q_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
    {
      float tmp376_375 = (arrayOfFloat1[k] = (float)Math.cos(f * (k + 1)));
      arrayOfFloat2[k] = tmp376_375;
      arrayOfFloat3[k] = tmp376_375;
    }
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    arrayOfFloat3 = this.l_quant_past_frame_2;
    arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp443_442 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp443_442;
      arrayOfFloat5[k] = tmp443_442;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729_tables.g729_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * arrayOfFloat3[k]);
    }
    float tmp551_550 = 0.0F;
    this.lp.past_lar[1] = tmp551_550;
    this.lp.past_lar[0] = tmp551_550;
    this.lp.rc0 = (this.lp.rc1 = 0.0F);
    this.lp.flat = 1;
    this.filters.preproc = this.preproc;
    this.filters.sinthesis = this.sinthesis;
    this.filters.error = this.error;
    this.filters.weghted_sinthesis_zero = this.weghted_sinthesis_zero;
    this.filters.weghted_sinthesis_pole = this.weghted_sinthesis_pole;
    this.filters.weghted_zero = this.weghted_zero;
    this.filters.weghted_pole = this.weghted_pole;
    this.speech.past_subframe_3 = this.past_subframe_3;
    this.speech.past_subframe_2 = this.past_subframe_2;
    this.speech.past_subframe_1 = this.past_subframe_1;
    this.speech.present_subframe_1 = this.present_subframe_1;
    this.speech.present_subframe_2 = this.present_subframe_2;
    this.speech.future_subframe = this.future_subframe;
    this.speech.weighted_speech = this.weighted_speech;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
    float tmp834_833 = (this.exc_err[2] = this.exc_err[3] = 1.0F);
    this.exc_err[1] = tmp834_833;
    this.exc_err[0] = tmp834_833;
  }

  public final void reset()
  {
    this.preproc.a0 = 0.4636372F;
    this.preproc.a1 = -0.9272471F;
    this.preproc.a2 = 0.4636372F;
    this.preproc.b1 = 1.905947F;
    this.preproc.b2 = -0.911402F;
    this.preproc.x1 = 0.0F;
    this.preproc.x2 = 0.0F;
    this.preproc.y1 = 0.0F;
    this.preproc.y2 = 0.0F;
    g729_utils.g729_set_0(this.sinthesis.delay, 0, 10);
    g729_utils.g729_set_0(this.error.delay, 0, 10);
    g729_utils.g729_set_0(this.weghted_sinthesis_zero.delay, 0, 10);
    g729_utils.g729_set_0(this.weghted_sinthesis_pole.delay, 0, 10);
    g729_utils.g729_set_0(this.weghted_zero.delay, 0, 10);
    g729_utils.g729_set_0(this.weghted_pole.delay, 0, 10);
    g729_utils.g729_set_0(this.past_subframe_3, 0, 40);
    g729_utils.g729_set_0(this.past_subframe_2, 0, 40);
    g729_utils.g729_set_0(this.past_subframe_1, 0, 40);
    g729_utils.g729_set_0(this.present_subframe_1, 0, 40);
    g729_utils.g729_set_0(this.weighted_speech, 0, 144);
    g729_utils.g729_set_0(this.excitation, 0, 154);
    int tmp254_253 = (this.speech.U[2] = this.speech.U[3] = 0);
    this.speech.U[1] = tmp254_253;
    this.speech.U[0] = tmp254_253;
    this.speech.past_quan_gp = 0.2000122F;
    g729_utils.g729_set_0(this.lp.a_subframe2, 0, 10);
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float[] arrayOfFloat2 = this.lp.q_present_subframe_2;
    float[] arrayOfFloat3 = this.lp.q_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
    {
      float tmp334_333 = (arrayOfFloat1[k] = (float)Math.cos(f * (k + 1)));
      arrayOfFloat2[k] = tmp334_333;
      arrayOfFloat3[k] = tmp334_333;
    }
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    arrayOfFloat3 = this.l_quant_past_frame_2;
    arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp401_400 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp401_400;
      arrayOfFloat5[k] = tmp401_400;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729_tables.g729_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * arrayOfFloat3[k]);
    }
    float tmp509_508 = 0.0F;
    this.lp.past_lar[1] = tmp509_508;
    this.lp.past_lar[0] = tmp509_508;
    this.lp.rc0 = (this.lp.rc1 = 0.0F);
    this.lp.flat = 1;
    this.filters.preproc = this.preproc;
    this.filters.sinthesis = this.sinthesis;
    this.filters.error = this.error;
    this.filters.weghted_sinthesis_zero = this.weghted_sinthesis_zero;
    this.filters.weghted_sinthesis_pole = this.weghted_sinthesis_pole;
    this.filters.weghted_zero = this.weghted_zero;
    this.filters.weghted_pole = this.weghted_pole;
    this.speech.past_subframe_3 = this.past_subframe_3;
    this.speech.past_subframe_2 = this.past_subframe_2;
    this.speech.past_subframe_1 = this.past_subframe_1;
    this.speech.present_subframe_1 = this.present_subframe_1;
    this.speech.present_subframe_2 = this.present_subframe_2;
    this.speech.future_subframe = this.future_subframe;
    this.speech.weighted_speech = this.weighted_speech;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
    float tmp792_791 = (this.exc_err[2] = this.exc_err[3] = 1.0F);
    this.exc_err[1] = tmp792_791;
    this.exc_err[0] = tmp792_791;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g729.g729_encoder
 * JD-Core Version:    0.6.0
 */