package codecLib.g729a;

final class g729a_encoder
  implements g729a_constants
{
  g729a_preproc_filter preproc = new g729a_preproc_filter();
  g729a_sinthesis_filter sinthesis = new g729a_sinthesis_filter();
  g729a_sinthesis_filter weghted_sinthesis = new g729a_sinthesis_filter();
  g729a_sinthesis_filter weghted = new g729a_sinthesis_filter();
  g729a_encode_filters filters;
  g729a_encode_speech speech;
  g729a_encode_lp lp;
  float[] past_subframe_3 = new float[40];
  float[] past_subframe_2 = new float[40];
  float[] past_subframe_1 = new float[40];
  float[] present_subframe_1 = new float[40];
  float[] present_subframe_2 = new float[40];
  float[] future_subframe = new float[40];
  float[] weighted_speech = new float['à'];
  float[] excitation = new float['Â'];
  float[] q_quant_past_subframe_2 = new float[10];
  float[] q_quant_present_subframe_2 = new float[10];
  float[] l_quant_past_frame_4 = new float[10];
  float[] l_quant_past_frame_3 = new float[10];
  float[] l_quant_past_frame_2 = new float[10];
  float[] l_quant_past_frame_1 = new float[10];
  float[] exc_err = new float[4];

  void encode(G729aCode paramG729aCode, short[] paramArrayOfShort)
  {
    g729a_encode_internal localg729a_encode_internal = new g729a_encode_internal();
    float[] arrayOfFloat4 = new float[40];
    float[][] arrayOfFloat5 = new float[3][40];
    float[][] arrayOfFloat6 = new float[3][];
    g729a_utils.validateData(paramArrayOfShort, 0);
    localg729a_encode_internal.r = arrayOfFloat4;
    arrayOfFloat6[0] = arrayOfFloat5[0];
    arrayOfFloat6[1] = arrayOfFloat5[1];
    arrayOfFloat6[2] = arrayOfFloat5[2];
    g729a_pre_proc.g729a_preproc_filter(this.speech.present_subframe_2, paramArrayOfShort, 0, this.filters);
    g729a_pre_proc.g729a_preproc_filter(this.speech.future_subframe, paramArrayOfShort, 40, this.filters);
    g729a_lpc.g729a_lp_analysis(this.lp.q, this.speech);
    g729a_qua_lsp.g729a_qua_lsp_encode(this.lp, paramG729aCode);
    g729a_common.g729a_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
    g729a_common.g729a_LSP2LP(localg729a_encode_internal.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
    g729a_common.g729a_LSP2LP(localg729a_encode_internal.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
    float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
    this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
    this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
    g729a_pwf.g729a_pwf(this.speech.weighted_speech, 0, this.speech.excitation, 154, this.speech.present_subframe_1, localg729a_encode_internal.a_quant_subframe1, this.filters);
    g729a_pwf.g729a_pwf(this.speech.weighted_speech, 40, localg729a_encode_internal.r, 0, this.speech.present_subframe_2, localg729a_encode_internal.a_quant_subframe2, this.filters);
    localg729a_encode_internal.T_opt = g729a_pitch.g729a_opla(this.speech.weighted_speech);
    g729a_pitch.g729a_impulse_response(localg729a_encode_internal, localg729a_encode_internal.a_quant_subframe1);
    g729a_pitch.g729a_target(localg729a_encode_internal, this.speech, this.filters);
    g729a_pitch.g729a_ad_cod_search_1(paramG729aCode, localg729a_encode_internal, this.speech, arrayOfFloat6);
    g729a_pitch.g729a_adcb_gain(localg729a_encode_internal);
    localg729a_encode_internal.taming = g729a_pitch.g729a_test_err(this.exc_err, localg729a_encode_internal.T1, localg729a_encode_internal.frac_T1);
    if ((localg729a_encode_internal.taming == 1) && (localg729a_encode_internal.gp > 0.9499512F))
      localg729a_encode_internal.gp = 0.9499512F;
    g729a_acelp_co.g729a_fc_search(localg729a_encode_internal, localg729a_encode_internal.T1, this.speech.past_quan_gp);
    g729a_qua_gain.g729a_qua_gain(localg729a_encode_internal, this.speech);
    paramG729aCode.setC1(localg729a_encode_internal.C);
    paramG729aCode.setS1(localg729a_encode_internal.S);
    paramG729aCode.setGA1(localg729a_encode_internal.GA);
    paramG729aCode.setGB1(localg729a_encode_internal.GB);
    g729a_qua_gain.g729a_memory_update_1(this.speech, localg729a_encode_internal, this.filters);
    g729a_pitch.g729a_update_exc_err(this.exc_err, localg729a_encode_internal.gp_quan, localg729a_encode_internal.T1);
    g729a_pitch.g729a_impulse_response(localg729a_encode_internal, localg729a_encode_internal.a_quant_subframe2);
    g729a_pitch.g729a_target(localg729a_encode_internal, this.speech, this.filters);
    g729a_pitch.g729a_ad_cod_search_2(paramG729aCode, localg729a_encode_internal, this.speech, arrayOfFloat6);
    g729a_pitch.g729a_adcb_gain(localg729a_encode_internal);
    localg729a_encode_internal.taming = g729a_pitch.g729a_test_err(this.exc_err, localg729a_encode_internal.T2, localg729a_encode_internal.frac_T2);
    if ((localg729a_encode_internal.taming == 1) && (localg729a_encode_internal.gp > 0.9499512F))
      localg729a_encode_internal.gp = 0.9499512F;
    g729a_acelp_co.g729a_fc_search(localg729a_encode_internal, localg729a_encode_internal.T2, this.speech.past_quan_gp);
    g729a_qua_gain.g729a_qua_gain(localg729a_encode_internal, this.speech);
    paramG729aCode.setC2(localg729a_encode_internal.C);
    paramG729aCode.setS2(localg729a_encode_internal.S);
    paramG729aCode.setGA2(localg729a_encode_internal.GA);
    paramG729aCode.setGB2(localg729a_encode_internal.GB);
    g729a_qua_gain.g729a_memory_update_2(this.speech, localg729a_encode_internal, this.filters);
    g729a_pitch.g729a_update_exc_err(this.exc_err, localg729a_encode_internal.gp_quan, localg729a_encode_internal.T2);
    float[] arrayOfFloat2 = this.speech.past_subframe_3;
    float[] arrayOfFloat3 = this.speech.past_subframe_2;
    this.speech.past_subframe_3 = this.speech.past_subframe_1;
    this.speech.past_subframe_2 = this.speech.present_subframe_1;
    this.speech.past_subframe_1 = this.speech.present_subframe_2;
    this.speech.present_subframe_1 = this.speech.future_subframe;
    this.speech.present_subframe_2 = arrayOfFloat2;
    this.speech.future_subframe = arrayOfFloat3;
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2, int paramInt3)
  {
    int k = paramInt2;
    int j = paramInt1;
    for (int i = 0; i < paramInt3; i++)
    {
      encode(paramArrayOfByte, j, paramArrayOfShort, k);
      k += 80;
      j += 10;
    }
  }

  public void encode(G729aCode[] paramArrayOfG729aCode, short[] paramArrayOfShort, int paramInt1, int paramInt2)
  {
    if (paramArrayOfG729aCode.length < paramInt2)
      throw new G729aException(1);
    int j = paramInt1;
    for (int i = 0; i < paramInt2; i++)
    {
      encode(paramArrayOfG729aCode[i], paramArrayOfShort, j);
      j += 80;
    }
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2)
  {
    G729aCode localG729aCode = new G729aCode();
    g729a_utils.validateCode(paramArrayOfByte, paramInt1);
    g729a_utils.validateData(paramArrayOfShort, paramInt2);
    encode(localG729aCode, paramArrayOfShort, paramInt2);
    byte[] arrayOfByte = localG729aCode.getData();
    System.arraycopy(arrayOfByte, 0, paramArrayOfByte, paramInt1, 10);
  }

  public void encode(G729aCode paramG729aCode, short[] paramArrayOfShort, int paramInt)
  {
    short[] arrayOfShort = new short[80];
    g729a_utils.validateData(paramArrayOfShort, paramInt);
    System.arraycopy(paramArrayOfShort, paramInt, arrayOfShort, 0, 80);
    encode(paramG729aCode, arrayOfShort);
  }

  public g729a_encoder()
  {
    g729a_preproc_filter localg729a_preproc_filter = this.preproc;
    g729a_sinthesis_filter localg729a_sinthesis_filter1 = this.sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter2 = this.weghted_sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter3 = this.weghted;
    localg729a_preproc_filter.a0 = 0.4636372F;
    localg729a_preproc_filter.a1 = -0.9272471F;
    localg729a_preproc_filter.a2 = 0.4636372F;
    localg729a_preproc_filter.b1 = 1.905947F;
    localg729a_preproc_filter.b2 = -0.911402F;
    localg729a_preproc_filter.x1 = 0.0F;
    localg729a_preproc_filter.x2 = 0.0F;
    localg729a_preproc_filter.y1 = 0.0F;
    localg729a_preproc_filter.y2 = 0.0F;
    this.speech = new g729a_encode_speech();
    this.speech.past_quan_gp = 0.2000122F;
    this.lp = new g729a_encode_lp();
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float[] arrayOfFloat2 = this.lp.q;
    float f = 0.2855994F;
    for (int i = 0; i < 10; i++)
    {
      arrayOfFloat1[i] = (float)Math.cos(f * (i + 1));
      arrayOfFloat2[i] = arrayOfFloat1[i];
    }
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int i = 0; i < 10; i++)
    {
      float tmp392_391 = (arrayOfFloat3[i] = arrayOfFloat2[i] = (i + 1) * f);
      arrayOfFloat4[i] = tmp392_391;
      arrayOfFloat5[i] = tmp392_391;
    }
    for (int j = 0; j < 2; j++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      arrayOfFloat1 = g729a_tables.g729a_fg_sum;
      for (int i = 0; i < 10; i++)
        arrayOfFloat2[(i + 10 * j)] = ((1.0F - arrayOfFloat1[(i + 10 * j)]) * arrayOfFloat3[i]);
    }
    this.filters = new g729a_encode_filters();
    this.filters.preproc = localg729a_preproc_filter;
    this.filters.sinthesis = localg729a_sinthesis_filter1;
    this.filters.weghted_sinthesis = localg729a_sinthesis_filter2;
    this.filters.weghted = localg729a_sinthesis_filter3;
    this.speech.past_subframe_3 = this.past_subframe_3;
    this.speech.past_subframe_2 = this.past_subframe_2;
    this.speech.past_subframe_1 = this.past_subframe_1;
    this.speech.present_subframe_1 = this.present_subframe_1;
    this.speech.present_subframe_2 = this.present_subframe_2;
    this.speech.future_subframe = this.future_subframe;
    this.speech.weighted_speech = this.weighted_speech;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
    float tmp703_702 = (this.exc_err[2] = this.exc_err[3] = 1.0F);
    this.exc_err[1] = tmp703_702;
    this.exc_err[0] = tmp703_702;
  }

  void reset()
  {
    g729a_preproc_filter localg729a_preproc_filter = this.preproc;
    g729a_sinthesis_filter localg729a_sinthesis_filter1 = this.sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter2 = this.weghted_sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter3 = this.weghted;
    localg729a_preproc_filter.a0 = 0.4636372F;
    localg729a_preproc_filter.a1 = -0.9272471F;
    localg729a_preproc_filter.a2 = 0.4636372F;
    localg729a_preproc_filter.b1 = 1.905947F;
    localg729a_preproc_filter.b2 = -0.911402F;
    localg729a_preproc_filter.x1 = 0.0F;
    localg729a_preproc_filter.x2 = 0.0F;
    localg729a_preproc_filter.y1 = 0.0F;
    localg729a_preproc_filter.y2 = 0.0F;
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter1.delay, 10);
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter2.delay, 10);
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter3.delay, 10);
    g729a_utils.g729a_set_0(this.past_subframe_3, 40);
    g729a_utils.g729a_set_0(this.past_subframe_2, 40);
    g729a_utils.g729a_set_0(this.past_subframe_1, 40);
    g729a_utils.g729a_set_0(this.present_subframe_1, 40);
    g729a_utils.g729a_set_0(this.weighted_speech, 144);
    g729a_utils.g729a_set_0(this.excitation, 154);
    int tmp192_191 = (this.speech.U[2] = this.speech.U[3] = 0);
    this.speech.U[1] = tmp192_191;
    this.speech.U[0] = tmp192_191;
    this.speech.past_quan_gp = 0.2000122F;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float[] arrayOfFloat2 = this.lp.q;
    float f = 0.2855994F;
    for (int i = 0; i < 10; i++)
    {
      arrayOfFloat1[i] = (float)Math.cos(f * (i + 1));
      arrayOfFloat2[i] = arrayOfFloat1[i];
    }
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int i = 0; i < 10; i++)
    {
      float tmp325_324 = (arrayOfFloat3[i] = arrayOfFloat2[i] = (i + 1) * f);
      arrayOfFloat4[i] = tmp325_324;
      arrayOfFloat5[i] = tmp325_324;
    }
    for (int j = 0; j < 2; j++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      arrayOfFloat1 = g729a_tables.g729a_fg_sum;
      for (int i = 0; i < 10; i++)
        arrayOfFloat2[(i + 10 * j)] = ((1.0F - arrayOfFloat1[(i + 10 * j)]) * arrayOfFloat3[i]);
    }
    this.filters.preproc = localg729a_preproc_filter;
    this.filters.sinthesis = localg729a_sinthesis_filter1;
    this.filters.weghted_sinthesis = localg729a_sinthesis_filter2;
    this.filters.weghted = localg729a_sinthesis_filter3;
    this.speech.past_subframe_3 = this.past_subframe_3;
    this.speech.past_subframe_2 = this.past_subframe_2;
    this.speech.past_subframe_1 = this.past_subframe_1;
    this.speech.present_subframe_1 = this.present_subframe_1;
    this.speech.present_subframe_2 = this.present_subframe_2;
    this.speech.future_subframe = this.future_subframe;
    this.speech.weighted_speech = this.weighted_speech;
    this.speech.excitation = this.excitation;
    this.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.l_quant_past_frame_1 = this.l_quant_past_frame_1;
    float tmp607_606 = (this.exc_err[2] = this.exc_err[3] = 1.0F);
    this.exc_err[1] = tmp607_606;
    this.exc_err[0] = tmp607_606;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g729a.g729a_encoder
 * JD-Core Version:    0.6.0
 */