/*
 * @(#)ControllerListener.java	1.2 02/08/21
 *
 * Copyright (c) 1996-2002 Sun Microsystems, Inc.  All rights reserved.
 */

package javax.media;

/**
 * <CODE>ControllerListener</CODE> is an interface for handling asynchronous
 * events generated by <code>Controllers</code>.
 *
 * <h2>Java Beans Support </h2>
 * If implementations of this interface are going to be used with
 * Java Beans they need to also implement either java.util.EventListener
 * or sunw.util.EventListener.
 *
 *
 * @see Controller
 * 
 * @version 1.2, 02/08/21
 *
 */
public interface ControllerListener {

    /**
     * This method is called when an event is generated by a 
     * <code>Controller</code> that this listener is registered with.
     *
     * @param event The event generated.
     */
    void controllerUpdate(ControllerEvent event);
}
