/*
 * @(#)GainChangeListener.java	1.2 02/08/21
 *
 * Copyright (c) 1996-2002 Sun Microsystems, Inc.  All rights reserved.
 */

package javax.media;

/**
 * <CODE>GainChangeListener</CODE> is an interface for handling
 * <code>GainChangeEvents</code> generated by 
 * <code>GainControls</code>.
 *
 * <h2>Java Beans support</h2>
 * It is required that any implementation of this object is
 * sub-classed either from java.util.EventListener, or
 * sunw.util.EventListener.
 *
 *
 * @see GainControl
 * @see GainChangeEvent
 * 
 * @version 1.2, 02/08/21.
*/
public interface GainChangeListener {

    /**
     * This method is called to deliver a <code>GainChangeEvent</code>
     * when the state of a <code>GainControl</code> changes.
     *
     * @param event The event generated.
     */
    void gainChange(GainChangeEvent event);
}
