/*
 * @(#)StopTimeChangeEvent.java	1.2 02/08/21
 *
 * Copyright (c) 1996-2002 Sun Microsystems, Inc.  All rights reserved.
 */

package javax.media;

/**
 * A <code>StopTimeChangeEvent</code> is generated by a <code>Controller</code> when its stop time
 * has changed.
 *
 * @see Controller
 * @see ControllerListener
 * @version 1.2, 02/08/21.
 */
public class StopTimeChangeEvent extends ControllerEvent {


    Time stopTime;
    
    public StopTimeChangeEvent(Controller from, Time newStopTime) {
	super(from);
	stopTime = newStopTime;
    }

    /**
     * Get the new stop-time for the <code>Controller</code> that
     * generated this event.
     *
     * @return The new stop time for the <code>Controller</code> that generated this event.
     */
    public Time getStopTime() {
	return stopTime;
    }

    /**
     * Returns the String representation of this event's values.
     */
    public String toString() {
	return getClass().getName() + "[source=" + eventSrc + 
	    ",stopTime=" + stopTime + "]";
    }
}
