/*
 * @(#)DataSinkListener.java	1.6 02/08/21
 *
 * Copyright (c) 1996-2002 Sun Microsystems, Inc.  All rights reserved.
 */

package javax.media.datasink;

/**
 * <CODE>DataSinkListener</CODE> is an interface for handling asynchronous
 * events generated by <code>DataSink</code>.
 *
 * @see javax.media.DataSink
 * 
 * @since JMF 2.0
 *
 */
public interface DataSinkListener {

    /**
     * This method is called when an event is generated by a 
     * <code>DataSink</code> that this listener is registered with.
     *
     * @param event The event generated.
     */
    void dataSinkUpdate(DataSinkEvent event);
}
