/*
 * @(#)MathUtils.java 
 * 
 * Copyright (c) 2013 Werner Randelshofer, Goldau, Switzerland.
 * All rights reserved.
 * 
 * You may not use, copy or modify this file, except in compliance with the 
 * license agreement you entered into with Werner Randelshofer. 
 * For details see accompanying license terms.
 */
package org.monte.media.math;

import static java.lang.Math.*;

/**
 * {@code MathUtils}.
 *
 * @author Werner Randelshofer
 * @version $Id: MathUtils.java 322 2013-04-09 11:13:22Z werner $
 */
public class MathUtils {

    public static float clamp(float value, float minValue, float maxValue) {
        return max(minValue, min(value, maxValue));

    }
    public static double clamp(double value, double minValue, double maxValue) {
        return max(minValue, min(value, maxValue));

    }
    public static int clamp(int value, int minValue, int maxValue) {
        return max(minValue, min(value, maxValue));

    }
    public static long clamp(long value, long minValue, long maxValue) {
        return max(minValue, min(value, maxValue));

    }
}
