package codecLib.g728;

public class Decoder
  implements Constants
{
  private g728_decoder decoder;

  public Decoder()
  {
    this.decoder = new g728_decoder(true);
  }

  public Decoder(boolean paramBoolean)
  {
    this.decoder = new g728_decoder(paramBoolean);
  }

  public void reset()
  {
    reset(true);
  }

  public void reset(boolean paramBoolean)
  {
    this.decoder.reset(paramBoolean);
  }

  public boolean getUsePostFilter()
  {
    return this.decoder.postfilter;
  }

  public void setUsePostFilter(boolean paramBoolean)
  {
    this.decoder.postfilter = paramBoolean;
  }

  public void decode(short[] paramArrayOfShort, int paramInt, short paramShort)
  {
    this.decoder.decode(paramArrayOfShort, paramInt, paramShort);
  }

  public void decode(short[] paramArrayOfShort1, int paramInt1, short[] paramArrayOfShort2, int paramInt2)
  {
    for (int i = 0; i < 4; i++)
      decode(paramArrayOfShort1, paramInt1 + i * 5, paramArrayOfShort2[(paramInt2 + i)]);
  }

  public void decode(short[] paramArrayOfShort1, int paramInt1, short[] paramArrayOfShort2, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      decode(paramArrayOfShort1, paramInt1 + i * 20, paramArrayOfShort2, paramInt2 + i * 4);
  }

  public void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2)
  {
    short[] arrayOfShort = new short[4];
    unpack(arrayOfShort, 0, paramArrayOfByte, paramInt2);
    decode(paramArrayOfShort, paramInt1, arrayOfShort, 0);
  }

  public void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      decode(paramArrayOfShort, paramInt1 + i * 20, paramArrayOfByte, paramInt2 + i * 4);
  }

  public static void unpack(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2)
  {
    g728_utils.validatePackedData(paramArrayOfByte, paramInt2, paramArrayOfShort, paramInt1);
    int i = 0xFF & paramArrayOfByte[paramInt2];
    int j = 0xFF & paramArrayOfByte[(paramInt2 + 1)];
    int k = 0xFF & paramArrayOfByte[(paramInt2 + 2)];
    int m = 0xFF & paramArrayOfByte[(paramInt2 + 3)];
    int n = 0xFF & paramArrayOfByte[(paramInt2 + 4)];
    paramArrayOfShort[paramInt1] = (short)(i << 2 | j >> 6);
    paramArrayOfShort[(paramInt1 + 1)] = (short)((j << 4 | k >> 4) & 0x3FF);
    paramArrayOfShort[(paramInt1 + 2)] = (short)((k << 6 | m >> 2) & 0x3FF);
    paramArrayOfShort[(paramInt1 + 3)] = (short)((m << 8 | n) & 0x3FF);
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.Decoder
 * JD-Core Version:    0.6.0
 */