package codecLib.g728;

public class Encoder
  implements Constants
{
  private g728_encoder encoder = new g728_encoder();

  public final void reset()
  {
    this.encoder.reset();
  }

  public short encode(short[] paramArrayOfShort, int paramInt)
  {
    return this.encoder.encode(paramArrayOfShort, paramInt);
  }

  public void encode(short[] paramArrayOfShort1, int paramInt1, short[] paramArrayOfShort2, int paramInt2)
  {
    for (int i = 0; i < 4; i++)
      paramArrayOfShort1[(paramInt1 + i)] = encode(paramArrayOfShort2, paramInt2 + i * 5);
  }

  public void encode(short[] paramArrayOfShort1, int paramInt1, short[] paramArrayOfShort2, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      encode(paramArrayOfShort1, paramInt1 + i * 4, paramArrayOfShort2, paramInt2 + i * 20);
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2)
  {
    short[] arrayOfShort = new short[4];
    encode(arrayOfShort, 0, paramArrayOfShort, paramInt2);
    pack(paramArrayOfByte, paramInt1, arrayOfShort, 0);
  }

  public void encode(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      encode(paramArrayOfByte, paramInt1 + i * 5, paramArrayOfShort, paramInt2 + i * 20);
  }

  public static void pack(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2)
  {
    g728_utils.validatePackedData(paramArrayOfByte, paramInt1, paramArrayOfShort, paramInt2);
    int i = paramArrayOfShort[paramInt2] & 0x3FF;
    int j = paramArrayOfShort[(paramInt2 + 1)] & 0x3FF;
    int k = paramArrayOfShort[(paramInt2 + 2)] & 0x3FF;
    int m = paramArrayOfShort[(paramInt2 + 3)] & 0x3FF;
    paramArrayOfByte[paramInt1] = (byte)(i >> 2);
    paramArrayOfByte[(paramInt1 + 1)] = (byte)(i << 6 | j >> 4);
    paramArrayOfByte[(paramInt1 + 2)] = (byte)(j << 4 | k >> 6);
    paramArrayOfByte[(paramInt1 + 3)] = (byte)(k << 2 | m >> 8);
    paramArrayOfByte[(paramInt1 + 4)] = (byte)m;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.Encoder
 * JD-Core Version:    0.6.0
 */