package codecLib.g728;

final class g728_decoder
  implements Constants, g728_constants
{
  boolean postfilter;
  double[] quantized_speech = new double[260];
  double[] ao_bsf = new double[50];
  double[] an_bsf = new double[50];
  int count;
  g728_gain gain;
  g728_filter_bs bsf;
  g728_filter_ps psf;

  g728_decoder(boolean paramBoolean)
  {
    this.postfilter = paramBoolean;
    this.count = 0;
    g728_utils.Clean(this.ao_bsf);
    g728_utils.Clean(this.quantized_speech);
    this.bsf = new g728_filter_bs(this.quantized_speech, 240, this.an_bsf, this.ao_bsf);
    this.psf = new g728_filter_ps(this.quantized_speech, 240);
    this.gain = new g728_gain();
    g728_utils.SetValue(this.gain.gain_filter.delay, -32.0D);
  }

  final void reset(boolean paramBoolean)
  {
    this.postfilter = paramBoolean;
    this.count = 0;
    g728_utils.Clean(this.ao_bsf);
    g728_utils.Clean(this.quantized_speech);
    this.bsf.reset();
    this.psf.reset();
    this.gain.reset();
    g728_utils.SetValue(this.gain.gain_filter.delay, -32.0D);
  }

  final void decode(short[] paramArrayOfShort, int paramInt, short paramShort)
  {
    g728_utils.validateData(paramArrayOfShort, paramInt);
    double[] arrayOfDouble1 = new double[5];
    double[] arrayOfDouble2 = new double[5];
    int k = this.count;
    int i;
    if (this.postfilter == true)
      i = 240;
    else
      i = 105;
    double d1 = this.gain.Predict();
    g728_codebook.Excitation(arrayOfDouble1, paramShort, d1);
    this.gain.Update(arrayOfDouble1);
    int j = 240 + 5 * k;
    this.bsf.Reconstruct_speech(arrayOfDouble1, j);
    this.count = (k + 1 & 0x3);
    int m;
    if (this.postfilter == true)
    {
      this.psf.Inverse_filter(this.psf.offset_d + 100 - 20 + 5 * (k + 1 & 0x3), j);
      if (k == 2)
        this.psf.Adapter(j);
      if (k == 0)
        this.psf.Coeff_calculate();
      this.psf.Postfilter(arrayOfDouble2, j);
      for (m = 0; m < 5; m++)
      {
        double d2 = arrayOfDouble2[m] * 8.0D;
        if (d2 > 0.0D)
        {
          if (d2 > 32767.0D)
            paramArrayOfShort[(paramInt + m)] = 32767;
          else
            paramArrayOfShort[(paramInt + m)] = (short)(int)(d2 + 0.5D);
        }
        else if (d2 < -32768.0D)
          paramArrayOfShort[(paramInt + m)] = -32768;
        else
          paramArrayOfShort[(paramInt + m)] = (short)(int)(d2 - 0.5D);
      }
    }
    else
    {
      for (m = 0; m < 5; m++)
        if (this.quantized_speech[(j + m)] > 0.0D)
          paramArrayOfShort[(paramInt + m)] = (short)(int)(this.quantized_speech[(j + m)] * 8.0D + 0.5D);
        else
          paramArrayOfShort[(paramInt + m)] = (short)(int)(this.quantized_speech[(j + m)] * 8.0D - 0.5D);
    }
    if (k == 0)
    {
      this.gain.Adapter();
      return;
    }
    if (k == 1)
    {
      if (this.bsf.test_bsf == 1)
      {
        double[] arrayOfDouble3 = this.bsf.ao_bsf;
        this.bsf.ao_bsf = this.bsf.an_bsf;
        this.bsf.an_bsf = arrayOfDouble3;
        return;
      }
    }
    else if (k == 3)
      this.bsf.Adapter(this.psf, i);
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.g728_decoder
 * JD-Core Version:    0.6.0
 */