package codecLib.g728;

final class g728_encoder
  implements Constants, g728_constants
{
  double[] quantized_speech = new double[125];
  double[] ao_bsf = new double[50];
  double[] an_bsf = new double[50];
  int count = 0;
  g728_gain gain;
  g728_codebook codebook;
  g728_filter_bs bsf;
  g728_filter_pw pwf;

  g728_encoder()
  {
    g728_utils.Clean(this.ao_bsf);
    g728_utils.Clean(this.an_bsf);
    g728_utils.Clean(this.quantized_speech);
    this.bsf = new g728_filter_bs(this.quantized_speech, 105, this.an_bsf, this.ao_bsf);
    this.pwf = new g728_filter_pw();
    this.gain = new g728_gain();
    this.codebook = new g728_codebook();
    g728_utils.SetValue(this.gain.gain_filter.delay, -32.0D);
  }

  final void reset()
  {
    this.count = 0;
    g728_utils.Clean(this.ao_bsf);
    g728_utils.Clean(this.an_bsf);
    g728_utils.Clean(this.quantized_speech);
    this.bsf.reset();
    this.pwf.reset();
    this.gain.reset();
    this.codebook.reset();
    g728_utils.SetValue(this.gain.gain_filter.delay, -32.0D);
  }

  final short encode(short[] paramArrayOfShort, int paramInt)
  {
    g728_utils.validateData(paramArrayOfShort, paramInt);
    double[] arrayOfDouble1 = new double[5];
    double[] arrayOfDouble2 = new double[5];
    double[] arrayOfDouble3 = new double[5];
    double[] arrayOfDouble4 = new double[1];
    double[] arrayOfDouble5 = new double[10];
    double d = 0.0D;
    int j = this.count;
    int k = 5 * (j + 2 & 0x3);
    for (int m = 0; m < 5; m++)
      this.pwf.present_speech[(k + m)] = (paramArrayOfShort[(paramInt + m)] * 0.125D);
    this.pwf.PWFilter(arrayOfDouble1, k);
    d = this.gain.Predict();
    this.pwf.Target(arrayOfDouble2, arrayOfDouble1, this.bsf, 1.0D / d);
    int i = this.codebook.Index(arrayOfDouble2);
    g728_codebook.Excitation(arrayOfDouble3, i, d);
    this.gain.Update(arrayOfDouble3);
    this.pwf.Update(this.bsf, 5 * j, arrayOfDouble3);
    this.count = (j + 1 & 0x3);
    if (j == 0)
    {
      this.gain.Adapter();
    }
    else if (j == 1)
    {
      this.pwf.Adapter();
      if (this.bsf.test_bsf == 1)
      {
        double[] arrayOfDouble6 = this.bsf.ao_bsf;
        this.bsf.ao_bsf = this.bsf.an_bsf;
        this.bsf.an_bsf = arrayOfDouble6;
      }
      if ((this.bsf.test_bsf == 1) || (this.pwf.test_pwf == 1))
      {
        this.pwf.Impulse_vcalv(this.codebook, this.bsf);
        this.codebook.Shape_convolution();
      }
    }
    else if (j == 3)
    {
      this.bsf.Adapter(arrayOfDouble5, arrayOfDouble4, 105);
    }
    return (short)i;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.g728_encoder
 * JD-Core Version:    0.6.0
 */