package codecLib.g728;

final class g728_utils
  implements g728_constants
{
  static void validateData(short[] paramArrayOfShort, int paramInt)
  {
    if ((paramInt < 0) || (paramInt > paramArrayOfShort.length))
      throw new G728Exception(2);
    if (paramArrayOfShort.length - paramInt < 5)
      throw new G728Exception(1);
  }

  static void validatePackedData(byte[] paramArrayOfByte, int paramInt1, short[] paramArrayOfShort, int paramInt2)
  {
    if ((paramInt2 < 0) || (paramInt2 > paramArrayOfShort.length))
      throw new G728Exception(2);
    if (paramArrayOfShort.length - paramInt2 < 4)
      throw new G728Exception(1);
    if ((paramInt1 < 0) || (paramInt1 > paramArrayOfByte.length))
      throw new G728Exception(2);
    if (paramArrayOfByte.length - paramInt1 < 5)
      throw new G728Exception(1);
  }

  static void SetValue(double[] paramArrayOfDouble, double paramDouble)
  {
    for (int i = 0; i < paramArrayOfDouble.length; i++)
      paramArrayOfDouble[i] = paramDouble;
  }

  static void Clean(double[] paramArrayOfDouble)
  {
    for (int i = 0; i < paramArrayOfDouble.length; i++)
      paramArrayOfDouble[i] = 0.0D;
  }

  static void Left_shift(double[] paramArrayOfDouble, int paramInt1, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      paramArrayOfDouble[(paramInt1 + i)] = paramArrayOfDouble[(paramInt1 + i + paramInt2)];
  }

  static void Copy(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      paramArrayOfDouble1[(paramInt1 + i)] = paramArrayOfDouble2[(paramInt2 + i)];
  }

  static void Windowing(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, double[] paramArrayOfDouble3, int paramInt3)
  {
    for (int i = 0; i < paramInt3; i++)
      paramArrayOfDouble2[(paramInt2 + i)] *= paramArrayOfDouble3[i];
  }

  static void IIR_50(double[] paramArrayOfDouble1, double[] paramArrayOfDouble2, double[] paramArrayOfDouble3)
  {
    double[] arrayOfDouble1 = new double[5];
    double[] arrayOfDouble2 = new double[5];
    double d1 = paramArrayOfDouble2[40];
    double d2 = paramArrayOfDouble2[41];
    double d3 = paramArrayOfDouble2[42];
    double d4 = paramArrayOfDouble2[43];
    double d5 = paramArrayOfDouble2[44];
    double d6 = paramArrayOfDouble2[45];
    double d7 = paramArrayOfDouble2[46];
    double d8 = paramArrayOfDouble2[47];
    double d9 = paramArrayOfDouble2[48];
    double d10 = paramArrayOfDouble2[49];
    double d12 = paramArrayOfDouble3[40];
    double d13 = paramArrayOfDouble3[41];
    double d14 = paramArrayOfDouble3[42];
    double d15 = paramArrayOfDouble3[43];
    double d16 = paramArrayOfDouble3[44];
    double d17 = paramArrayOfDouble3[45];
    double d18 = paramArrayOfDouble3[46];
    double d19 = paramArrayOfDouble3[47];
    double d20 = paramArrayOfDouble3[48];
    double d21 = paramArrayOfDouble3[49];
    double d11;
    for (int i = 0; i < 5; i++)
    {
      d11 = -d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = paramArrayOfDouble3[(39 - i)];
      arrayOfDouble1[i] = d11;
    }
    paramArrayOfDouble3[40] = d12;
    paramArrayOfDouble3[41] = d13;
    paramArrayOfDouble3[42] = d14;
    paramArrayOfDouble3[43] = d15;
    paramArrayOfDouble3[44] = d16;
    paramArrayOfDouble3[45] = d17;
    paramArrayOfDouble3[46] = d18;
    paramArrayOfDouble3[47] = d19;
    paramArrayOfDouble3[48] = d20;
    paramArrayOfDouble3[49] = d21;
    d1 = paramArrayOfDouble2[30];
    d2 = paramArrayOfDouble2[31];
    d3 = paramArrayOfDouble2[32];
    d4 = paramArrayOfDouble2[33];
    d5 = paramArrayOfDouble2[34];
    d6 = paramArrayOfDouble2[35];
    d7 = paramArrayOfDouble2[36];
    d8 = paramArrayOfDouble2[37];
    d9 = paramArrayOfDouble2[38];
    d10 = paramArrayOfDouble2[39];
    d12 = paramArrayOfDouble3[30];
    d13 = paramArrayOfDouble3[31];
    d14 = paramArrayOfDouble3[32];
    d15 = paramArrayOfDouble3[33];
    d16 = paramArrayOfDouble3[34];
    d17 = paramArrayOfDouble3[35];
    d18 = paramArrayOfDouble3[36];
    d19 = paramArrayOfDouble3[37];
    d20 = paramArrayOfDouble3[38];
    d21 = paramArrayOfDouble3[39];
    for (int j = 0; j < 5; j++)
    {
      d11 = arrayOfDouble1[j] - d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = paramArrayOfDouble3[(29 - j)];
      arrayOfDouble2[j] = d11;
    }
    paramArrayOfDouble3[30] = d12;
    paramArrayOfDouble3[31] = d13;
    paramArrayOfDouble3[32] = d14;
    paramArrayOfDouble3[33] = d15;
    paramArrayOfDouble3[34] = d16;
    paramArrayOfDouble3[35] = d17;
    paramArrayOfDouble3[36] = d18;
    paramArrayOfDouble3[37] = d19;
    paramArrayOfDouble3[38] = d20;
    paramArrayOfDouble3[39] = d21;
    d1 = paramArrayOfDouble2[20];
    d2 = paramArrayOfDouble2[21];
    d3 = paramArrayOfDouble2[22];
    d4 = paramArrayOfDouble2[23];
    d5 = paramArrayOfDouble2[24];
    d6 = paramArrayOfDouble2[25];
    d7 = paramArrayOfDouble2[26];
    d8 = paramArrayOfDouble2[27];
    d9 = paramArrayOfDouble2[28];
    d10 = paramArrayOfDouble2[29];
    d12 = paramArrayOfDouble3[20];
    d13 = paramArrayOfDouble3[21];
    d14 = paramArrayOfDouble3[22];
    d15 = paramArrayOfDouble3[23];
    d16 = paramArrayOfDouble3[24];
    d17 = paramArrayOfDouble3[25];
    d18 = paramArrayOfDouble3[26];
    d19 = paramArrayOfDouble3[27];
    d20 = paramArrayOfDouble3[28];
    d21 = paramArrayOfDouble3[29];
    for (int k = 0; k < 5; k++)
    {
      d11 = arrayOfDouble2[k] - d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = paramArrayOfDouble3[(19 - k)];
      arrayOfDouble1[k] = d11;
    }
    paramArrayOfDouble3[20] = d12;
    paramArrayOfDouble3[21] = d13;
    paramArrayOfDouble3[22] = d14;
    paramArrayOfDouble3[23] = d15;
    paramArrayOfDouble3[24] = d16;
    paramArrayOfDouble3[25] = d17;
    paramArrayOfDouble3[26] = d18;
    paramArrayOfDouble3[27] = d19;
    paramArrayOfDouble3[28] = d20;
    paramArrayOfDouble3[29] = d21;
    d1 = paramArrayOfDouble2[10];
    d2 = paramArrayOfDouble2[11];
    d3 = paramArrayOfDouble2[12];
    d4 = paramArrayOfDouble2[13];
    d5 = paramArrayOfDouble2[14];
    d6 = paramArrayOfDouble2[15];
    d7 = paramArrayOfDouble2[16];
    d8 = paramArrayOfDouble2[17];
    d9 = paramArrayOfDouble2[18];
    d10 = paramArrayOfDouble2[19];
    d12 = paramArrayOfDouble3[10];
    d13 = paramArrayOfDouble3[11];
    d14 = paramArrayOfDouble3[12];
    d15 = paramArrayOfDouble3[13];
    d16 = paramArrayOfDouble3[14];
    d17 = paramArrayOfDouble3[15];
    d18 = paramArrayOfDouble3[16];
    d19 = paramArrayOfDouble3[17];
    d20 = paramArrayOfDouble3[18];
    d21 = paramArrayOfDouble3[19];
    for (int m = 0; m < 5; m++)
    {
      d11 = arrayOfDouble1[m] - d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = paramArrayOfDouble3[(9 - m)];
      arrayOfDouble2[m] = d11;
    }
    paramArrayOfDouble3[10] = d12;
    paramArrayOfDouble3[11] = d13;
    paramArrayOfDouble3[12] = d14;
    paramArrayOfDouble3[13] = d15;
    paramArrayOfDouble3[14] = d16;
    paramArrayOfDouble3[15] = d17;
    paramArrayOfDouble3[16] = d18;
    paramArrayOfDouble3[17] = d19;
    paramArrayOfDouble3[18] = d20;
    paramArrayOfDouble3[19] = d21;
    d1 = paramArrayOfDouble2[0];
    d2 = paramArrayOfDouble2[1];
    d3 = paramArrayOfDouble2[2];
    d4 = paramArrayOfDouble2[3];
    d5 = paramArrayOfDouble2[4];
    d6 = paramArrayOfDouble2[5];
    d7 = paramArrayOfDouble2[6];
    d8 = paramArrayOfDouble2[7];
    d9 = paramArrayOfDouble2[8];
    d10 = paramArrayOfDouble2[9];
    d12 = paramArrayOfDouble3[0];
    d13 = paramArrayOfDouble3[1];
    d14 = paramArrayOfDouble3[2];
    d15 = paramArrayOfDouble3[3];
    d16 = paramArrayOfDouble3[4];
    d17 = paramArrayOfDouble3[5];
    d18 = paramArrayOfDouble3[6];
    d19 = paramArrayOfDouble3[7];
    d20 = paramArrayOfDouble3[8];
    d21 = paramArrayOfDouble3[9];
    for (int n = 0; n < 5; n++)
    {
      d11 = arrayOfDouble2[n] - d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = d11;
      paramArrayOfDouble1[n] = d11;
    }
    paramArrayOfDouble3[0] = d12;
    paramArrayOfDouble3[1] = d13;
    paramArrayOfDouble3[2] = d14;
    paramArrayOfDouble3[3] = d15;
    paramArrayOfDouble3[4] = d16;
    paramArrayOfDouble3[5] = d17;
    paramArrayOfDouble3[6] = d18;
    paramArrayOfDouble3[7] = d19;
    paramArrayOfDouble3[8] = d20;
    paramArrayOfDouble3[9] = d21;
  }

  static void IIR(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, double[] paramArrayOfDouble3, double[] paramArrayOfDouble4)
  {
    double d12 = paramArrayOfDouble4[0];
    double d13 = paramArrayOfDouble4[1];
    double d14 = paramArrayOfDouble4[2];
    double d15 = paramArrayOfDouble4[3];
    double d16 = paramArrayOfDouble4[4];
    double d17 = paramArrayOfDouble4[5];
    double d18 = paramArrayOfDouble4[6];
    double d19 = paramArrayOfDouble4[7];
    double d20 = paramArrayOfDouble4[8];
    double d21 = paramArrayOfDouble4[9];
    double d1 = paramArrayOfDouble3[0];
    double d2 = paramArrayOfDouble3[1];
    double d3 = paramArrayOfDouble3[2];
    double d4 = paramArrayOfDouble3[3];
    double d5 = paramArrayOfDouble3[4];
    double d6 = paramArrayOfDouble3[5];
    double d7 = paramArrayOfDouble3[6];
    double d8 = paramArrayOfDouble3[7];
    double d9 = paramArrayOfDouble3[8];
    double d10 = paramArrayOfDouble3[9];
    for (int i = 0; i < 5; i++)
    {
      double d22 = paramArrayOfDouble2[(paramInt2 + i)];
      double d11 = d22 - d10 * d21 - d9 * d20 - d8 * d19 - d7 * d18 - d6 * d17 - d5 * d16 - d4 * d15 - d3 * d14 - d2 * d13 - d1 * d12;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      d12 = d11;
      paramArrayOfDouble1[(paramInt1 + i)] = d11;
    }
    paramArrayOfDouble4[0] = d12;
    paramArrayOfDouble4[1] = d13;
    paramArrayOfDouble4[2] = d14;
    paramArrayOfDouble4[3] = d15;
    paramArrayOfDouble4[4] = d16;
    paramArrayOfDouble4[5] = d17;
    paramArrayOfDouble4[6] = d18;
    paramArrayOfDouble4[7] = d19;
    paramArrayOfDouble4[8] = d20;
    paramArrayOfDouble4[9] = d21;
  }

  static void FIR(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, double[] paramArrayOfDouble3, double[] paramArrayOfDouble4)
  {
    double d13 = paramArrayOfDouble4[0];
    double d14 = paramArrayOfDouble4[1];
    double d15 = paramArrayOfDouble4[2];
    double d16 = paramArrayOfDouble4[3];
    double d17 = paramArrayOfDouble4[4];
    double d18 = paramArrayOfDouble4[5];
    double d19 = paramArrayOfDouble4[6];
    double d20 = paramArrayOfDouble4[7];
    double d21 = paramArrayOfDouble4[8];
    double d22 = paramArrayOfDouble4[9];
    double d2 = paramArrayOfDouble3[0];
    double d3 = paramArrayOfDouble3[1];
    double d4 = paramArrayOfDouble3[2];
    double d5 = paramArrayOfDouble3[3];
    double d6 = paramArrayOfDouble3[4];
    double d7 = paramArrayOfDouble3[5];
    double d8 = paramArrayOfDouble3[6];
    double d9 = paramArrayOfDouble3[7];
    double d10 = paramArrayOfDouble3[8];
    double d11 = paramArrayOfDouble3[9];
    for (int i = 0; i < 5; i++)
    {
      double d12 = paramArrayOfDouble2[(paramInt2 + i)];
      double d1 = d12 + d11 * d22 + d10 * d21 + d9 * d20 + d8 * d19 + d7 * d18 + d6 * d17 + d5 * d16 + d4 * d15 + d3 * d14 + d2 * d13;
      d22 = d21;
      d21 = d20;
      d20 = d19;
      d19 = d18;
      d18 = d17;
      d17 = d16;
      d16 = d15;
      d15 = d14;
      d14 = d13;
      d13 = d12;
      paramArrayOfDouble1[(paramInt1 + i)] = d1;
    }
    paramArrayOfDouble4[0] = d13;
    paramArrayOfDouble4[1] = d14;
    paramArrayOfDouble4[2] = d15;
    paramArrayOfDouble4[3] = d16;
    paramArrayOfDouble4[4] = d17;
    paramArrayOfDouble4[5] = d18;
    paramArrayOfDouble4[6] = d19;
    paramArrayOfDouble4[7] = d20;
    paramArrayOfDouble4[8] = d21;
    paramArrayOfDouble4[9] = d22;
  }

  static void Corel_10(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, int paramInt3, int paramInt4)
  {
    double d12 = paramArrayOfDouble1[paramInt1];
    double d13 = paramArrayOfDouble1[(paramInt1 + 1)];
    double d14 = paramArrayOfDouble1[(paramInt1 + 2)];
    double d15 = paramArrayOfDouble1[(paramInt1 + 3)];
    double d16 = paramArrayOfDouble1[(paramInt1 + 4)];
    double d17 = paramArrayOfDouble1[(paramInt1 + 5)];
    double d18 = paramArrayOfDouble1[(paramInt1 + 6)];
    double d19 = paramArrayOfDouble1[(paramInt1 + 7)];
    double d20 = paramArrayOfDouble1[(paramInt1 + 8)];
    double d21 = paramArrayOfDouble1[(paramInt1 + 9)];
    double d1 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 1 - paramInt4)];
    double d2 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 2 - paramInt4)];
    double d3 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 3 - paramInt4)];
    double d4 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 4 - paramInt4)];
    double d5 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 5 - paramInt4)];
    double d6 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 6 - paramInt4)];
    double d7 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 7 - paramInt4)];
    double d8 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 8 - paramInt4)];
    double d9 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 9 - paramInt4)];
    for (int i = paramInt3; i > 0; i--)
    {
      double d11 = paramArrayOfDouble2[(paramInt2 + i - 1)];
      double d10 = paramArrayOfDouble2[(paramInt2 + i - 10 - paramInt4)];
      d12 += d1 * d11;
      d13 += d2 * d11;
      d14 += d3 * d11;
      d15 += d4 * d11;
      d16 += d5 * d11;
      d17 += d6 * d11;
      d18 += d7 * d11;
      d19 += d8 * d11;
      d20 += d9 * d11;
      d21 += d10 * d11;
      d1 = d2;
      d2 = d3;
      d3 = d4;
      d4 = d5;
      d5 = d6;
      d6 = d7;
      d7 = d8;
      d8 = d9;
      d9 = d10;
    }
    paramArrayOfDouble1[paramInt1] = d12;
    paramArrayOfDouble1[(paramInt1 + 1)] = d13;
    paramArrayOfDouble1[(paramInt1 + 2)] = d14;
    paramArrayOfDouble1[(paramInt1 + 3)] = d15;
    paramArrayOfDouble1[(paramInt1 + 4)] = d16;
    paramArrayOfDouble1[(paramInt1 + 5)] = d17;
    paramArrayOfDouble1[(paramInt1 + 6)] = d18;
    paramArrayOfDouble1[(paramInt1 + 7)] = d19;
    paramArrayOfDouble1[(paramInt1 + 8)] = d20;
    paramArrayOfDouble1[(paramInt1 + 9)] = d21;
  }

  static void Corel_11(double[] paramArrayOfDouble1, int paramInt1, double[] paramArrayOfDouble2, int paramInt2, int paramInt3)
  {
    double d12 = paramArrayOfDouble1[paramInt1];
    double d13 = paramArrayOfDouble1[(paramInt1 + 1)];
    double d14 = paramArrayOfDouble1[(paramInt1 + 2)];
    double d15 = paramArrayOfDouble1[(paramInt1 + 3)];
    double d16 = paramArrayOfDouble1[(paramInt1 + 4)];
    double d17 = paramArrayOfDouble1[(paramInt1 + 5)];
    double d18 = paramArrayOfDouble1[(paramInt1 + 6)];
    double d19 = paramArrayOfDouble1[(paramInt1 + 7)];
    double d20 = paramArrayOfDouble1[(paramInt1 + 8)];
    double d21 = paramArrayOfDouble1[(paramInt1 + 9)];
    double d22 = paramArrayOfDouble1[(paramInt1 + 10)];
    double d1 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 1)];
    double d2 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 2)];
    double d3 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 3)];
    double d4 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 4)];
    double d5 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 5)];
    double d6 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 6)];
    double d7 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 7)];
    double d8 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 8)];
    double d9 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 9)];
    double d10 = paramArrayOfDouble2[(paramInt2 + paramInt3 - 10)];
    for (int i = paramInt3; i > 0; i--)
    {
      double d11 = paramArrayOfDouble2[(paramInt2 + i - 11)];
      d12 += d1 * d1;
      d13 += d1 * d2;
      d14 += d1 * d3;
      d15 += d1 * d4;
      d16 += d1 * d5;
      d17 += d1 * d6;
      d18 += d1 * d7;
      d19 += d1 * d8;
      d20 += d1 * d9;
      d21 += d1 * d10;
      d22 += d1 * d11;
      d1 = d2;
      d2 = d3;
      d3 = d4;
      d4 = d5;
      d5 = d6;
      d6 = d7;
      d7 = d8;
      d8 = d9;
      d9 = d10;
      d10 = d11;
    }
    paramArrayOfDouble1[paramInt1] = d12;
    paramArrayOfDouble1[(paramInt1 + 1)] = d13;
    paramArrayOfDouble1[(paramInt1 + 2)] = d14;
    paramArrayOfDouble1[(paramInt1 + 3)] = d15;
    paramArrayOfDouble1[(paramInt1 + 4)] = d16;
    paramArrayOfDouble1[(paramInt1 + 5)] = d17;
    paramArrayOfDouble1[(paramInt1 + 6)] = d18;
    paramArrayOfDouble1[(paramInt1 + 7)] = d19;
    paramArrayOfDouble1[(paramInt1 + 8)] = d20;
    paramArrayOfDouble1[(paramInt1 + 9)] = d21;
    paramArrayOfDouble1[(paramInt1 + 10)] = d22;
  }

  static double Levdur_10(double[] paramArrayOfDouble1, double[] paramArrayOfDouble2, double[] paramArrayOfDouble3)
  {
    double d1 = paramArrayOfDouble2[0];
    double d2 = paramArrayOfDouble2[1];
    double d3 = paramArrayOfDouble2[2];
    double d4 = paramArrayOfDouble2[3];
    double d5 = paramArrayOfDouble2[4];
    double d6 = paramArrayOfDouble2[5];
    double d7 = paramArrayOfDouble2[6];
    double d8 = paramArrayOfDouble2[7];
    double d9 = paramArrayOfDouble2[8];
    double d10 = paramArrayOfDouble2[9];
    double d11 = paramArrayOfDouble2[10];
    if ((d1 <= 0.0D) || (d11 == 0.0D))
      return 0.0D;
    double d22 = -d2 / d1;
    paramArrayOfDouble3[0] = d22;
    double d12 = d22;
    double d23 = d1 * (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d3 + d12 * d2) / d23;
    d12 += d22 * d12;
    double d13 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d4 + d12 * d3 + d13 * d2) / d23;
    double d24 = d12;
    d12 += d22 * d13;
    d13 += d22 * d24;
    double d14 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d5 + d12 * d4 + d13 * d3 + d14 * d2) / d23;
    d24 = d12;
    d12 += d22 * d14;
    d13 += d22 * d13;
    d14 += d22 * d24;
    double d15 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d6 + d12 * d5 + d13 * d4 + d14 * d3 + d15 * d2) / d23;
    d24 = d12;
    d12 += d22 * d15;
    d15 += d22 * d24;
    d24 = d13;
    d13 += d22 * d14;
    d14 += d22 * d24;
    double d16 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d7 + d12 * d6 + d13 * d5 + d14 * d4 + d15 * d3 + d16 * d2) / d23;
    d24 = d12;
    d12 += d22 * d16;
    d16 += d22 * d24;
    d24 = d13;
    d13 += d22 * d15;
    d15 += d22 * d24;
    d14 += d22 * d14;
    double d17 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d8 + d12 * d7 + d13 * d6 + d14 * d5 + d15 * d4 + d16 * d3 + d17 * d2) / d23;
    d24 = d12;
    d12 += d22 * d17;
    d17 += d22 * d24;
    d24 = d13;
    d13 += d22 * d16;
    d16 += d22 * d24;
    d24 = d14;
    d14 += d22 * d15;
    d15 += d22 * d24;
    double d18 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d9 + d12 * d8 + d13 * d7 + d14 * d6 + d15 * d5 + d16 * d4 + d17 * d3 + d18 * d2) / d23;
    d24 = d12;
    d12 += d22 * d18;
    d18 += d22 * d24;
    d24 = d13;
    d13 += d22 * d17;
    d17 += d22 * d24;
    d24 = d14;
    d14 += d22 * d16;
    d16 += d22 * d24;
    d15 += d22 * d15;
    double d19 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d10 + d12 * d9 + d13 * d8 + d14 * d7 + d15 * d6 + d16 * d5 + d17 * d4 + d18 * d3 + d19 * d2) / d23;
    d24 = d12;
    d12 += d22 * d19;
    d19 += d22 * d24;
    d24 = d13;
    d13 += d22 * d18;
    d18 += d22 * d24;
    d24 = d14;
    d14 += d22 * d17;
    d17 += d22 * d24;
    d24 = d15;
    d15 += d22 * d16;
    d16 += d22 * d24;
    double d20 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    d22 = -(d11 + d12 * d10 + d13 * d9 + d14 * d8 + d15 * d7 + d16 * d6 + d17 * d5 + d18 * d4 + d19 * d3 + d20 * d2) / d23;
    d24 = d12;
    d12 += d22 * d20;
    d20 += d22 * d24;
    d24 = d13;
    d13 += d22 * d19;
    d19 += d22 * d24;
    d24 = d14;
    d14 += d22 * d18;
    d18 += d22 * d24;
    d24 = d15;
    d15 += d22 * d17;
    d17 += d22 * d24;
    d16 += d22 * d16;
    double d21 = d22;
    d23 *= (1.0D - d22 * d22);
    if (d23 <= 0.0D)
      return 0.0D;
    paramArrayOfDouble1[0] = d12;
    paramArrayOfDouble1[1] = d13;
    paramArrayOfDouble1[2] = d14;
    paramArrayOfDouble1[3] = d15;
    paramArrayOfDouble1[4] = d16;
    paramArrayOfDouble1[5] = d17;
    paramArrayOfDouble1[6] = d18;
    paramArrayOfDouble1[7] = d19;
    paramArrayOfDouble1[8] = d20;
    paramArrayOfDouble1[9] = d21;
    return d23;
  }

  static double Levdur_50(double[] paramArrayOfDouble1, double[] paramArrayOfDouble2, double paramDouble)
  {
    if (paramArrayOfDouble2[50] == 0.0D)
      return 0.0D;
    for (int i = 10; i < 50; i++)
    {
      double d8 = -paramArrayOfDouble2[(i + 1)];
      double d6 = paramArrayOfDouble2[i];
      double d7 = paramArrayOfDouble1[0];
      double d5 = d6 * d7;
      d6 = paramArrayOfDouble2[(i - 1)];
      d7 = paramArrayOfDouble1[1];
      for (int j = 2; j < i; j++)
      {
        d8 -= d5;
        d5 = d6 * d7;
        d6 = paramArrayOfDouble2[(i - j)];
        d7 = paramArrayOfDouble1[j];
      }
      d8 -= d5;
      d5 = d6 * d7;
      d8 -= d5;
      d8 /= paramDouble;
      int k = i + 1 >> 1;
      int m = 0;
      int n = i - 1;
      for (int i1 = 0; i1 < k; i1++)
      {
        double d9 = paramArrayOfDouble1[m];
        double d10 = paramArrayOfDouble1[n];
        double d1 = d8 * d9;
        double d2 = d8 * d10;
        double d4 = d2 + d9;
        double d3 = d1 + d10;
        paramArrayOfDouble1[m] = d4;
        paramArrayOfDouble1[n] = d3;
        m++;
        n--;
      }
      paramArrayOfDouble1[i] = d8;
      paramDouble *= (1.0D - d8 * d8);
      if (paramDouble <= 0.0D)
        return 0.0D;
    }
    return 1.0D;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g728.g728_utils
 * JD-Core Version:    0.6.0
 */