package codecLib.g729;

final class g729_decoder
  implements g729_constants
{
  private g729_preproc_filter postproc = new g729_preproc_filter();
  private g729_sinthesis_filter sinthesis = new g729_sinthesis_filter();
  private g729_sinthesis_filter residual_filter = new g729_sinthesis_filter();
  private g729_sinthesis_filter shortterm = new g729_sinthesis_filter();
  private g729_tilt_filter tilt = new g729_tilt_filter();
  private g729_decode_filters filters = new g729_decode_filters();
  private g729_decode_speech speech = new g729_decode_speech();
  private g729_decode_lp lp = new g729_decode_lp();
  private float[] residual = new float['Â'];
  private float[] excitation = new float['Â'];
  private float[] q_quant_past_subframe_2 = new float[10];
  private float[] q_quant_present_subframe_2 = new float[10];
  private float[] l_quant_past_frame_4 = new float[10];
  private float[] l_quant_past_frame_3 = new float[10];
  private float[] l_quant_past_frame_2 = new float[10];
  private float[] l_quant_past_frame_1 = new float[10];

  final void decode(short[] paramArrayOfShort, G729Code paramG729Code, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729_decode_internal localg729_decode_internal1 = new g729_decode_internal();
    g729_decode_internal localg729_decode_internal2 = localg729_decode_internal1;
    g729_utils.validateData(paramArrayOfShort, 0);
    float[] arrayOfFloat2 = this.speech.U;
    if (!paramBoolean1)
    {
      this.speech.periodic = 0;
      if (!paramBoolean2)
        g729_reconstruct.g729_lspdec(this.lp, paramG729Code);
      else
        g729_reconstruct.g729_lspdec_erased(this.lp);
      g729_common.g729_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
      g729_common.g729_LSP2LP(localg729_decode_internal2.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
      g729_common.g729_LSP2LP(localg729_decode_internal2.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
      float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
      this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
      this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
      localg729_decode_internal2.C = paramG729Code.getC1();
      localg729_decode_internal2.S = paramG729Code.getS1();
      localg729_decode_internal2.GA = paramG729Code.getGA1();
      localg729_decode_internal2.GB = paramG729Code.getGB1();
      g729_reconstruct.g729_dec_lag3_1(paramG729Code, localg729_decode_internal2, this.speech);
      g729_reconstruct.g729_de_acelp(localg729_decode_internal2, localg729_decode_internal2.T1, this.speech.past_quan_gp);
      g729_reconstruct.g729_dec_gain(localg729_decode_internal2, this.speech);
      g729_reconstruct.g729_reconstruct_speech(localg729_decode_internal2, this.speech, this.filters, localg729_decode_internal2.a_quant_subframe1);
      g729_pst.g729_pst(this.speech, localg729_decode_internal2, this.filters, localg729_decode_internal2.a_quant_subframe1, localg729_decode_internal2.T1);
      g729_postprocessor.g729_postproc_filter(paramArrayOfShort, 0, localg729_decode_internal2.sf, this.filters);
      localg729_decode_internal2.C = paramG729Code.getC2();
      localg729_decode_internal2.S = paramG729Code.getS2();
      localg729_decode_internal2.GA = paramG729Code.getGA2();
      localg729_decode_internal2.GB = paramG729Code.getGB2();
      g729_reconstruct.g729_dec_lag3_2(paramG729Code, localg729_decode_internal2, this.speech);
      g729_reconstruct.g729_de_acelp(localg729_decode_internal2, this.speech.T2, this.speech.past_quan_gp);
      g729_reconstruct.g729_dec_gain(localg729_decode_internal2, this.speech);
      g729_reconstruct.g729_reconstruct_speech(localg729_decode_internal2, this.speech, this.filters, localg729_decode_internal2.a_quant_subframe2);
      g729_pst.g729_pst(this.speech, localg729_decode_internal2, this.filters, localg729_decode_internal2.a_quant_subframe2, localg729_decode_internal2.T1);
      g729_postprocessor.g729_postproc_filter(paramArrayOfShort, 40, localg729_decode_internal2.sf, this.filters);
      return;
    }
    g729_reconstruct.g729_lspdec_erased(this.lp);
    g729_common.g729_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
    g729_common.g729_LSP2LP(localg729_decode_internal2.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
    g729_common.g729_LSP2LP(localg729_decode_internal2.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
    float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
    this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
    this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
    int i;
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729_decode_internal2.C = (i & 0x1FFF);
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729_decode_internal2.S = (i & 0xF);
    if (this.speech.past_quan_gp > 0.9F)
      localg729_decode_internal2.gp_quan = 0.9F;
    else
      localg729_decode_internal2.gp_quan = (0.9F * this.speech.past_quan_gp);
    this.speech.past_quan_gp = localg729_decode_internal2.gp_quan;
    this.speech.past_quan_gc = (localg729_decode_internal2.gc_quan = 0.98F * this.speech.past_quan_gc);
    float f = 0.25F * (arrayOfFloat2[0] + arrayOfFloat2[1] + arrayOfFloat2[2] + arrayOfFloat2[3]) - 4.0F;
    if (f < -14.0F)
      f = -14.0F;
    arrayOfFloat2[3] = arrayOfFloat2[2];
    arrayOfFloat2[2] = arrayOfFloat2[1];
    arrayOfFloat2[1] = arrayOfFloat2[0];
    arrayOfFloat2[0] = f;
    int j = this.speech.T2;
    if (this.speech.periodic == 1)
    {
      g729_common.g729_generation_adaptive_vector(localg729_decode_internal2.v, this.speech.excitation, 154, this.speech.T2, 0);
      g729_utils.g729_set_0(localg729_decode_internal2.c, 0, 40);
    }
    else
    {
      g729_utils.g729_set_0(localg729_decode_internal2.v, 0, 40);
      g729_reconstruct.g729_de_acelp(localg729_decode_internal2, this.speech.T2, this.speech.past_quan_gp);
    }
    g729_reconstruct.g729_reconstruct_speech(localg729_decode_internal2, this.speech, this.filters, localg729_decode_internal2.a_quant_subframe1);
    g729_pst.g729_pst(this.speech, localg729_decode_internal2, this.filters, localg729_decode_internal2.a_quant_subframe1, this.speech.T2);
    g729_postprocessor.g729_postproc_filter(paramArrayOfShort, 0, localg729_decode_internal2.sf, this.filters);
    if (this.speech.T2 < 143)
      this.speech.T2 += 1;
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729_decode_internal2.C = (i & 0x1FFF);
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729_decode_internal2.S = (i & 0xF);
    if (this.speech.past_quan_gp > 0.9F)
      localg729_decode_internal2.gp_quan = 0.9F;
    else
      localg729_decode_internal2.gp_quan = (0.9F * this.speech.past_quan_gp);
    this.speech.past_quan_gp = localg729_decode_internal2.gp_quan;
    this.speech.past_quan_gc = (localg729_decode_internal2.gc_quan = 0.98F * this.speech.past_quan_gc);
    f = 0.25F * (arrayOfFloat2[0] + arrayOfFloat2[1] + arrayOfFloat2[2] + arrayOfFloat2[3]) - 4.0F;
    if (f < -14.0F)
      f = -14.0F;
    arrayOfFloat2[3] = arrayOfFloat2[2];
    arrayOfFloat2[2] = arrayOfFloat2[1];
    arrayOfFloat2[1] = arrayOfFloat2[0];
    arrayOfFloat2[0] = f;
    if (this.speech.periodic == 1)
    {
      g729_common.g729_generation_adaptive_vector(localg729_decode_internal2.v, this.speech.excitation, 154, this.speech.T2, 0);
      g729_utils.g729_set_0(localg729_decode_internal2.c, 0, 40);
    }
    else
    {
      g729_utils.g729_set_0(localg729_decode_internal2.v, 0, 40);
      g729_reconstruct.g729_de_acelp(localg729_decode_internal2, this.speech.T2, this.speech.past_quan_gp);
    }
    g729_reconstruct.g729_reconstruct_speech(localg729_decode_internal2, this.speech, this.filters, localg729_decode_internal2.a_quant_subframe2);
    g729_pst.g729_pst(this.speech, localg729_decode_internal2, this.filters, localg729_decode_internal2.a_quant_subframe2, j);
    g729_postprocessor.g729_postproc_filter(paramArrayOfShort, 40, localg729_decode_internal2.sf, this.filters);
    if (this.speech.T2 < 143)
      this.speech.T2 += 1;
  }

  void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2, int paramInt3)
  {
    int j = paramInt1;
    int k = paramInt2;
    for (int i = 0; i < paramInt3; i++)
    {
      decode(paramArrayOfShort, j, paramArrayOfByte, k, false, false);
      j += 80;
      k += 10;
    }
  }

  void decode(short[] paramArrayOfShort, int paramInt1, G729Code[] paramArrayOfG729Code, int paramInt2, boolean paramBoolean1, boolean paramBoolean2)
  {
    if (paramArrayOfG729Code.length < paramInt2)
      throw new G729Exception(1);
    int j = paramInt1;
    for (int i = 0; i < paramInt2; i++)
    {
      decode(paramArrayOfShort, j, paramArrayOfG729Code[i], paramBoolean1, paramBoolean2);
      j += 80;
    }
  }

  void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729_utils.validateCode(paramArrayOfByte, paramInt2);
    G729Code localG729Code = new G729Code(paramArrayOfByte, paramInt2);
    decode(paramArrayOfShort, paramInt1, localG729Code, paramBoolean1, paramBoolean2);
  }

  void decode(short[] paramArrayOfShort, int paramInt, G729Code paramG729Code, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729_utils.validateData(paramArrayOfShort, paramInt);
    short[] arrayOfShort = new short[80];
    decode(arrayOfShort, paramG729Code, paramBoolean1, paramBoolean2);
    System.arraycopy(arrayOfShort, 0, paramArrayOfShort, paramInt, 80);
  }

  g729_decoder()
  {
    this.postproc.a0 = 123182.23F;
    this.postproc.a1 = -246360.75F;
    this.postproc.a2 = 123182.23F;
    this.postproc.b1 = 1.933074F;
    this.postproc.b2 = -0.935792F;
    this.postproc.x1 = 0.0F;
    this.postproc.x2 = 0.0F;
    this.postproc.y1 = 0.0F;
    this.postproc.y2 = 0.0F;
    float tmp273_272 = (this.speech.U[2] = this.speech.U[3] = -14.0F);
    this.speech.U[1] = tmp273_272;
    this.speech.U[0] = tmp273_272;
    this.speech.past_quan_gp = 0.2000122F;
    this.speech.past_g = 0.0F;
    this.speech.seed = 21845;
    this.speech.T2 = 60;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
      arrayOfFloat1[k] = (float)Math.cos(f * (k + 1));
    for (int k = 0; k < 10; k++)
      this.lp.past_omega[k] = (f * (k + 1));
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    float[] arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp442_441 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp442_441;
      arrayOfFloat5[k] = tmp442_441;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729_tables.g729_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * f * (k + 1));
    }
    this.filters.postproc = this.postproc;
    this.filters.sinthesis = this.sinthesis;
    this.filters.residual = this.residual_filter;
    this.filters.shortterm = this.shortterm;
    this.filters.tilt = this.tilt;
    this.speech.residual = this.residual;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
  }

  final void reset()
  {
    this.postproc.a0 = 123182.23F;
    this.postproc.a1 = -246360.75F;
    this.postproc.a2 = 123182.23F;
    this.postproc.b1 = 1.933074F;
    this.postproc.b2 = -0.935792F;
    this.postproc.x1 = 0.0F;
    this.postproc.x2 = 0.0F;
    this.postproc.y1 = 0.0F;
    this.postproc.y2 = 0.0F;
    g729_utils.g729_set_0(this.sinthesis.delay, 0, 10);
    g729_utils.g729_set_0(this.residual_filter.delay, 0, 10);
    g729_utils.g729_set_0(this.shortterm.delay, 0, 10);
    this.tilt.x1 = 0.0F;
    g729_utils.g729_set_0(this.residual, 0, 194);
    g729_utils.g729_set_0(this.excitation, 0, 194);
    float tmp184_183 = (this.speech.U[2] = this.speech.U[3] = -14.0F);
    this.speech.U[1] = tmp184_183;
    this.speech.U[0] = tmp184_183;
    this.speech.past_quan_gp = 0.2000122F;
    this.speech.past_g = 0.0F;
    this.speech.seed = 21845;
    this.speech.T2 = 60;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
      arrayOfFloat1[k] = (float)Math.cos(f * (k + 1));
    for (int k = 0; k < 10; k++)
      this.lp.past_omega[k] = (f * (k + 1));
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    float[] arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp353_352 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp353_352;
      arrayOfFloat5[k] = tmp353_352;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729_tables.g729_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * f * (k + 1));
    }
    this.filters.postproc = this.postproc;
    this.filters.sinthesis = this.sinthesis;
    this.filters.residual = this.residual_filter;
    this.filters.shortterm = this.shortterm;
    this.filters.tilt = this.tilt;
    this.speech.residual = this.residual;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g729.g729_decoder
 * JD-Core Version:    0.6.0
 */