package codecLib.g729a;

final class g729a_decoder
  implements g729a_constants
{
  private g729a_preproc_filter postproc = new g729a_preproc_filter();
  private g729a_sinthesis_filter sinthesis = new g729a_sinthesis_filter();
  private g729a_sinthesis_filter residual_filter = new g729a_sinthesis_filter();
  private g729a_sinthesis_filter shortterm = new g729a_sinthesis_filter();
  private g729a_tilt_filter tilt = new g729a_tilt_filter();
  private g729a_decode_filters filters;
  private g729a_decode_speech speech;
  private g729a_decode_lp lp;
  private float[] residual = new float['¸'];
  private float[] excitation = new float['Â'];
  private float[] q_quant_past_subframe_2 = new float[10];
  private float[] q_quant_present_subframe_2 = new float[10];
  private float[] l_quant_past_frame_4 = new float[10];
  private float[] l_quant_past_frame_3 = new float[10];
  private float[] l_quant_past_frame_2 = new float[10];
  private float[] l_quant_past_frame_1 = new float[10];

  final void decode(short[] paramArrayOfShort, G729aCode paramG729aCode, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729a_decode_internal localg729a_decode_internal = new g729a_decode_internal();
    g729a_utils.validateData(paramArrayOfShort, 0);
    float[] arrayOfFloat2 = this.speech.U;
    if (!paramBoolean1)
    {
      this.speech.periodic = 0;
      if (!paramBoolean2)
        g729a_reconstruct.g729a_lspdec(this.lp, paramG729aCode);
      else
        g729a_reconstruct.g729a_lspdec_erased(this.lp);
      g729a_common.g729a_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
      g729a_common.g729a_LSP2LP(localg729a_decode_internal.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
      g729a_common.g729a_LSP2LP(localg729a_decode_internal.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
      float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
      this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
      this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
      localg729a_decode_internal.C = paramG729aCode.getC1();
      localg729a_decode_internal.S = paramG729aCode.getS1();
      localg729a_decode_internal.GA = paramG729aCode.getGA1();
      localg729a_decode_internal.GB = paramG729aCode.getGB1();
      g729a_reconstruct.g729a_dec_lag3_1(paramG729aCode, localg729a_decode_internal, this.speech);
      g729a_reconstruct.g729a_de_acelp(localg729a_decode_internal, localg729a_decode_internal.T1, this.speech.past_quan_gp);
      g729a_reconstruct.g729a_dec_gain(localg729a_decode_internal, this.speech);
      g729a_reconstruct.g729a_reconstruct_speech(localg729a_decode_internal, this.speech, this.filters, localg729a_decode_internal.a_quant_subframe1);
      g729a_pst.g729a_pst(this.speech, localg729a_decode_internal, this.filters, localg729a_decode_internal.a_quant_subframe1, localg729a_decode_internal.T1);
      g729a_post_pro.g729a_postproc_filter(paramArrayOfShort, 0, localg729a_decode_internal.sf, this.filters);
      localg729a_decode_internal.C = paramG729aCode.getC2();
      localg729a_decode_internal.S = paramG729aCode.getS2();
      localg729a_decode_internal.GA = paramG729aCode.getGA2();
      localg729a_decode_internal.GB = paramG729aCode.getGB2();
      g729a_reconstruct.g729a_dec_lag3_2(paramG729aCode, localg729a_decode_internal, this.speech);
      g729a_reconstruct.g729a_de_acelp(localg729a_decode_internal, this.speech.T2, this.speech.past_quan_gp);
      g729a_reconstruct.g729a_dec_gain(localg729a_decode_internal, this.speech);
      g729a_reconstruct.g729a_reconstruct_speech(localg729a_decode_internal, this.speech, this.filters, localg729a_decode_internal.a_quant_subframe2);
      g729a_pst.g729a_pst(this.speech, localg729a_decode_internal, this.filters, localg729a_decode_internal.a_quant_subframe2, this.speech.T2);
      g729a_post_pro.g729a_postproc_filter(paramArrayOfShort, 40, localg729a_decode_internal.sf, this.filters);
      return;
    }
    g729a_reconstruct.g729a_lspdec_erased(this.lp);
    g729a_common.g729a_lsp_interpolation(this.lp.q_quant_present_subframe_1, this.lp.q_quant_past_subframe_2, this.lp.q_quant_present_subframe_2);
    g729a_common.g729a_LSP2LP(localg729a_decode_internal.a_quant_subframe1, this.lp.q_quant_present_subframe_1);
    g729a_common.g729a_LSP2LP(localg729a_decode_internal.a_quant_subframe2, this.lp.q_quant_present_subframe_2);
    float[] arrayOfFloat1 = this.lp.q_quant_past_subframe_2;
    this.lp.q_quant_past_subframe_2 = this.lp.q_quant_present_subframe_2;
    this.lp.q_quant_present_subframe_2 = arrayOfFloat1;
    int i;
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729a_decode_internal.C = (i & 0x1FFF);
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729a_decode_internal.S = (i & 0xF);
    if (this.speech.past_quan_gp > 0.9F)
      localg729a_decode_internal.gp_quan = 0.9F;
    else
      localg729a_decode_internal.gp_quan = (0.9F * this.speech.past_quan_gp);
    this.speech.past_quan_gp = localg729a_decode_internal.gp_quan;
    this.speech.past_quan_gc = (localg729a_decode_internal.gc_quan = 0.98F * this.speech.past_quan_gc);
    float f = 0.25F * (arrayOfFloat2[0] + arrayOfFloat2[1] + arrayOfFloat2[2] + arrayOfFloat2[3]) - 4.0F;
    if (f < -14.0F)
      f = -14.0F;
    arrayOfFloat2[3] = arrayOfFloat2[2];
    arrayOfFloat2[2] = arrayOfFloat2[1];
    arrayOfFloat2[1] = arrayOfFloat2[0];
    arrayOfFloat2[0] = f;
    if (this.speech.periodic == 1)
    {
      g729a_common.g729a_generation_adaptive_vector(localg729a_decode_internal.v, this.speech.excitation, this.speech.T2, 0);
      g729a_utils.g729a_set_0(localg729a_decode_internal.c, 40);
    }
    else
    {
      g729a_utils.g729a_set_0(localg729a_decode_internal.v, 40);
      g729a_reconstruct.g729a_de_acelp(localg729a_decode_internal, this.speech.T2, this.speech.past_quan_gp);
    }
    g729a_reconstruct.g729a_reconstruct_speech(localg729a_decode_internal, this.speech, this.filters, localg729a_decode_internal.a_quant_subframe1);
    g729a_pst.g729a_pst(this.speech, localg729a_decode_internal, this.filters, localg729a_decode_internal.a_quant_subframe1, this.speech.T2);
    g729a_post_pro.g729a_postproc_filter(paramArrayOfShort, 0, localg729a_decode_internal.sf, this.filters);
    if (this.speech.T2 < 143)
      this.speech.T2 += 1;
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729a_decode_internal.C = (i & 0x1FFF);
    this.speech.seed = (i = this.speech.seed * 31821 + 13849);
    localg729a_decode_internal.S = (i & 0xF);
    if (this.speech.past_quan_gp > 0.9F)
      localg729a_decode_internal.gp_quan = 0.9F;
    else
      localg729a_decode_internal.gp_quan = (0.9F * this.speech.past_quan_gp);
    this.speech.past_quan_gp = localg729a_decode_internal.gp_quan;
    this.speech.past_quan_gc = (localg729a_decode_internal.gc_quan = 0.98F * this.speech.past_quan_gc);
    f = 0.25F * (arrayOfFloat2[0] + arrayOfFloat2[1] + arrayOfFloat2[2] + arrayOfFloat2[3]) - 4.0F;
    if (f < -14.0F)
      f = -14.0F;
    arrayOfFloat2[3] = arrayOfFloat2[2];
    arrayOfFloat2[2] = arrayOfFloat2[1];
    arrayOfFloat2[1] = arrayOfFloat2[0];
    arrayOfFloat2[0] = f;
    if (this.speech.periodic == 1)
    {
      g729a_common.g729a_generation_adaptive_vector(localg729a_decode_internal.v, this.speech.excitation, this.speech.T2, 0);
      g729a_utils.g729a_set_0(localg729a_decode_internal.c, 40);
    }
    else
    {
      g729a_utils.g729a_set_0(localg729a_decode_internal.v, 40);
      g729a_reconstruct.g729a_de_acelp(localg729a_decode_internal, this.speech.T2, this.speech.past_quan_gp);
    }
    g729a_reconstruct.g729a_reconstruct_speech(localg729a_decode_internal, this.speech, this.filters, localg729a_decode_internal.a_quant_subframe2);
    g729a_pst.g729a_pst(this.speech, localg729a_decode_internal, this.filters, localg729a_decode_internal.a_quant_subframe2, this.speech.T2);
    g729a_post_pro.g729a_postproc_filter(paramArrayOfShort, 40, localg729a_decode_internal.sf, this.filters);
    if (this.speech.T2 < 143)
      this.speech.T2 += 1;
  }

  void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2, int paramInt3)
  {
    int j = paramInt1;
    int k = paramInt2;
    for (int i = 0; i < paramInt3; i++)
    {
      decode(paramArrayOfShort, j, paramArrayOfByte, k, false, false);
      j += 80;
      k += 10;
    }
  }

  void decode(short[] paramArrayOfShort, int paramInt1, G729aCode[] paramArrayOfG729aCode, int paramInt2, boolean paramBoolean1, boolean paramBoolean2)
  {
    if (paramArrayOfG729aCode.length < paramInt2)
      throw new G729aException(1);
    int j = paramInt1;
    for (int i = 0; i < paramInt2; i++)
    {
      decode(paramArrayOfShort, j, paramArrayOfG729aCode[i], paramBoolean1, paramBoolean2);
      j += 80;
    }
  }

  void decode(short[] paramArrayOfShort, int paramInt1, byte[] paramArrayOfByte, int paramInt2, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729a_utils.validateCode(paramArrayOfByte, paramInt2);
    G729aCode localG729aCode = new G729aCode(paramArrayOfByte, paramInt2);
    decode(paramArrayOfShort, paramInt1, localG729aCode, paramBoolean1, paramBoolean2);
  }

  void decode(short[] paramArrayOfShort, int paramInt, G729aCode paramG729aCode, boolean paramBoolean1, boolean paramBoolean2)
  {
    g729a_utils.validateData(paramArrayOfShort, paramInt);
    short[] arrayOfShort = new short[80];
    decode(arrayOfShort, paramG729aCode, paramBoolean1, paramBoolean2);
    System.arraycopy(arrayOfShort, 0, paramArrayOfShort, paramInt, 80);
  }

  g729a_decoder()
  {
    g729a_preproc_filter localg729a_preproc_filter = this.postproc;
    g729a_sinthesis_filter localg729a_sinthesis_filter1 = this.sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter2 = this.residual_filter;
    g729a_sinthesis_filter localg729a_sinthesis_filter3 = this.shortterm;
    g729a_tilt_filter localg729a_tilt_filter = this.tilt;
    localg729a_preproc_filter.a0 = 123182.23F;
    localg729a_preproc_filter.a1 = -246360.75F;
    localg729a_preproc_filter.a2 = 123182.23F;
    localg729a_preproc_filter.b1 = 1.933074F;
    localg729a_preproc_filter.b2 = -0.935792F;
    localg729a_preproc_filter.x1 = 0.0F;
    localg729a_preproc_filter.x2 = 0.0F;
    localg729a_preproc_filter.y1 = 0.0F;
    localg729a_preproc_filter.y2 = 0.0F;
    localg729a_tilt_filter.x1 = 0.0F;
    this.speech = new g729a_decode_speech();
    float tmp257_256 = (this.speech.U[2] = this.speech.U[3] = -14.0F);
    this.speech.U[1] = tmp257_256;
    this.speech.U[0] = tmp257_256;
    this.speech.past_quan_gp = 0.2000122F;
    this.speech.past_g = 0.0F;
    this.speech.seed = 21845;
    this.speech.T2 = 60;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
      arrayOfFloat1[k] = (float)Math.cos(f * (k + 1));
    this.lp = new g729a_decode_lp();
    for (int k = 0; k < 10; k++)
      this.lp.past_omega[k] = (f * (k + 1));
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    float[] arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp443_442 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp443_442;
      arrayOfFloat5[k] = tmp443_442;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729a_tables.g729a_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * f * (k + 1));
    }
    this.filters = new g729a_decode_filters();
    this.filters.postproc = localg729a_preproc_filter;
    this.filters.sinthesis = localg729a_sinthesis_filter1;
    this.filters.residual = localg729a_sinthesis_filter2;
    this.filters.shortterm = localg729a_sinthesis_filter3;
    this.filters.tilt = localg729a_tilt_filter;
    this.speech.residual = this.residual;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
  }

  void reset()
  {
    g729a_preproc_filter localg729a_preproc_filter = this.postproc;
    g729a_sinthesis_filter localg729a_sinthesis_filter1 = this.sinthesis;
    g729a_sinthesis_filter localg729a_sinthesis_filter2 = this.residual_filter;
    g729a_sinthesis_filter localg729a_sinthesis_filter3 = this.shortterm;
    g729a_tilt_filter localg729a_tilt_filter = this.tilt;
    localg729a_preproc_filter.a0 = 123182.23F;
    localg729a_preproc_filter.a1 = -246360.75F;
    localg729a_preproc_filter.a2 = 123182.23F;
    localg729a_preproc_filter.b1 = 1.933074F;
    localg729a_preproc_filter.b2 = -0.935792F;
    localg729a_preproc_filter.x1 = 0.0F;
    localg729a_preproc_filter.x2 = 0.0F;
    localg729a_preproc_filter.y1 = 0.0F;
    localg729a_preproc_filter.y2 = 0.0F;
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter1.delay, 10);
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter2.delay, 10);
    g729a_utils.g729a_set_0(localg729a_sinthesis_filter3.delay, 10);
    localg729a_tilt_filter.x1 = 0.0F;
    g729a_utils.g729a_set_0(this.residual, 184);
    g729a_utils.g729a_set_0(this.excitation, 194);
    float tmp169_168 = (this.speech.U[2] = this.speech.U[3] = -14.0F);
    this.speech.U[1] = tmp169_168;
    this.speech.U[0] = tmp169_168;
    this.speech.past_quan_gp = 0.2000122F;
    this.speech.past_g = 0.0F;
    this.speech.seed = 21845;
    this.speech.T2 = 60;
    float[] arrayOfFloat1 = this.q_quant_past_subframe_2;
    float f = 0.2855994F;
    for (int k = 0; k < 10; k++)
      arrayOfFloat1[k] = (float)Math.cos(f * (k + 1));
    for (int k = 0; k < 10; k++)
      this.lp.past_omega[k] = (f * (k + 1));
    float[] arrayOfFloat5 = this.l_quant_past_frame_4;
    float[] arrayOfFloat4 = this.l_quant_past_frame_3;
    float[] arrayOfFloat3 = this.l_quant_past_frame_2;
    float[] arrayOfFloat2 = this.l_quant_past_frame_1;
    for (int k = 0; k < 10; k++)
    {
      float tmp344_343 = (arrayOfFloat3[k] = arrayOfFloat2[k] = (k + 1) * f);
      arrayOfFloat4[k] = tmp344_343;
      arrayOfFloat5[k] = tmp344_343;
    }
    for (int m = 0; m < 2; m++)
    {
      arrayOfFloat2 = this.lp.fg_l_quant_sum;
      int j = 10 * m;
      arrayOfFloat1 = g729a_tables.g729a_fg_sum;
      int i = 10 * m;
      for (int k = 0; k < 10; k++)
        arrayOfFloat2[(k + j)] = ((1.0F - arrayOfFloat1[(k + i)]) * f * (k + 1));
    }
    this.filters.postproc = localg729a_preproc_filter;
    this.filters.sinthesis = localg729a_sinthesis_filter1;
    this.filters.residual = localg729a_sinthesis_filter2;
    this.filters.shortterm = localg729a_sinthesis_filter3;
    this.filters.tilt = localg729a_tilt_filter;
    this.speech.residual = this.residual;
    this.speech.excitation = this.excitation;
    this.lp.q_quant_past_subframe_2 = this.q_quant_past_subframe_2;
    this.lp.q_quant_present_subframe_2 = this.q_quant_present_subframe_2;
    this.lp.l_quant_past_frame_4 = this.l_quant_past_frame_4;
    this.lp.l_quant_past_frame_3 = this.l_quant_past_frame_3;
    this.lp.l_quant_past_frame_2 = this.l_quant_past_frame_2;
    this.lp.l_quant_past_frame_1 = this.l_quant_past_frame_1;
  }
}

/* Location:           /Users/Shared/Developer/Java/MonteMedia/current/trunk/MonteMedia/dist/monte-all.jar
 * Qualified Name:     codecLib.g729a.g729a_decoder
 * JD-Core Version:    0.6.0
 */